﻿'© By Andrea Bruno
'Open source, but: This source code (or part of this code) is not usable in other applications

Namespace WebApplication
	Public Module DatingManager
		Public DatingDataFile As String = Extension.MapPath(ReadWriteDirectory & "/dating.mdb")
		Class PersonalProfile
			Public ID As Integer = -1
			Public Disabled As Boolean
			Public DateOfCreation As Date
			Public RealName As String
			Public Pseudonym As String
			Public Gender As Authentication.User.GenderType
			Public BirthYear As Date
			Public TypeOfRelationship As Relationship
			Public Presentation As String
			Public AboutPartner As String
			Public Children As Integer
			Public PhotoAlbum As String
			Public Email As String
			Public Locality As String	'Country/City
			Public ICQ As Long
			Public ZodiacSign As ZodiacalSymbols
			Public FamilySituation As FamilySituation
			Public Eyes As EyesColor
			Public Hair As HairColor
			Public Weight As Integer
			Public Height As Integer
			Public WebSite As String
			Public Orientation As Orientation
			Function Save(Optional ByVal CloseConnection As Boolean = True) As Integer
				If DateOfCreation = Date.MinValue Then
					DateOfCreation = Now.ToUniversalTime
				End If
				'Dim KeyValue As New Collections.Generic.Dictionary(Of String, Object)
				Dim KeyValue As New Collections.Specialized.HybridDictionary
				KeyValue.Add("Disabled", Disabled)
				KeyValue.Add("DateOfCreation", DateOfCreation)
				KeyValue.Add("RealName", RealName)
				KeyValue.Add("Pseudonym", Pseudonym)
				KeyValue.Add("Gender", Gender)
				'If BirthYear <> Date.MinValue Then
				KeyValue.Add("BirthYear", BirthYear)
				'End If
				KeyValue.Add("TypeOfRelationship", TypeOfRelationship)
				KeyValue.Add("Presentation", Presentation)
				KeyValue.Add("AboutPartner", AboutPartner)
				KeyValue.Add("Children", Children)
				KeyValue.Add("PhotoAlbum", PhotoAlbum)
				KeyValue.Add("Email", Email)
				KeyValue.Add("Locality", Locality)
				KeyValue.Add("ICQ", ICQ)
				KeyValue.Add("ZodiacSign", ZodiacSign)
				KeyValue.Add("FamilySituation", FamilySituation)
				KeyValue.Add("Eyes", Eyes)
				KeyValue.Add("Hair", Hair)
				KeyValue.Add("Weight", Weight)
				KeyValue.Add("Height", Height)
				KeyValue.Add("WebSite", WebSite)
				KeyValue.Add("Orientation", Orientation)

				Me.ID = DataManager.AddRecord(DatingDataFile, "Persons", KeyValue, "ID", Me.ID, True, CloseConnection)
				Return Me.ID
			End Function
			Sub New()
			End Sub
			Sub New(ByVal Record As Data.OleDb.OleDbDataReader)
				On Error Resume Next
				ID = Record("ID")
				Disabled = Record("Disabled")
				DateOfCreation = Record("DateOfCreation")
				RealName = Record("RealName")
				Pseudonym = Record("Pseudonym")
				Gender = Record("Gender")
				BirthYear = Record("BirthYear")
				TypeOfRelationship = Record("TypeOfRelationship")
				Presentation = Record("Presentation")
				AboutPartner = Record("AboutPartner")
				Children = Record("Children")
				PhotoAlbum = Record("PhotoAlbum")
				Email = Record("Email")
				Locality = Record("Locality")
				ICQ = Record("ICQ")
				ZodiacSign = Record("ZodiacSign")
				FamilySituation = Record("FamilySituation")
				Eyes = Record("Eyes")
				Hair = Record("Hair")
				Weight = Record("Weight")
				Height = Record("Height")
				WebSite = Record("WebSite")
				Orientation = Record("Orientation")
			End Sub
			Function Card(ByVal Setting As SubSite) As Control
				Dim Ctrl As New Control
				If Me.PhotoAlbum <> "" Then
					Dim PhotoAlbum As PhotoAlbum = PhotoManager.PhotoAlbum.Load(Me.PhotoAlbum)
					If PhotoAlbum IsNot Nothing Then
						Ctrl.Controls.Add(PhotoAlbum.ControlPhotos(Setting, True))
					End If
				End If
				Dim Table As New HtmlTable
				Ctrl.Controls.Add(Table)
				If RealName <> "" Then
					AddRowInTable(Table, Phrase(Setting.Language, 24), RealName)
				End If
				If Pseudonym <> "" Then
					AddRowInTable(Table, Phrase(Setting.Language, 9), Pseudonym)
				End If
				If DateOfCreation > #7/16/2007# Then
					AddRowInTable(Table, Phrase(Setting.Language, 3349), DateOfCreation.ToString(Setting.DateFormat, Setting.Culture))
				End If
				Dim IdPhrase As Integer
				Select Case Gender
					Case User.GenderType.Male
						IdPhrase = 3133
					Case User.GenderType.Female
						IdPhrase = 3134
					Case User.GenderType.NotDefinite
						IdPhrase = 1347
				End Select
				AddRowInTable(Table, Phrase(Setting.Language, 19), Phrase(Setting.Language, IdPhrase))
				Dim Years As Integer = DateAndTime.DateDiff(DateInterval.Year, BirthYear, Now)
				If Years > 0 And Years < 90 Then
					AddRowInTable(Table, Phrase(Setting.Language, 3347), Years)
				End If
				Dim Text As String
				If TypeOfRelationship <> Relationship.Undefined Then
					Dim N As Integer
					For Each Relationship As Relationship In [Enum].GetValues(GetType(Relationship))
						If Relationship <> DatingManager.Relationship.Undefined Then
							If (TypeOfRelationship And Relationship) <> 0 Then
								Text += Phrase(Setting.Language, 3290 + N) & ","
							End If
						End If
						N += 1
					Next
					If Text <> "" Then
						Text = Left(Text, Len(Text) - 1)
						AddRowInTable(Table, Phrase(Setting.Language, 3289), Text)
					End If
				End If

				If Orientation <> DatingManager.Orientation.Undefined Then
					AddRowInTable(Table, Phrase(Setting.Language, 3320), Phrase(Setting.Language, 3318 + Orientation))
				End If
				If Len(Presentation) > 2 Then
					AddRowInTable(Table, Phrase(Setting.Language, 3345), Presentation)
				End If
				If Len(AboutPartner) > 2 Then
					AddRowInTable(Table, Phrase(Setting.Language, 3346), AboutPartner)
				End If
				If Email <> "" Then
					AddRowInTable(Table, Phrase(Setting.Language, 12), Email)
				End If
				If Locality <> "" Then
					AddRowInTable(Table, Phrase(Setting.Language, 17) & "/" & Phrase(Setting.Language, 16), Locality)
				End If
				If ICQ Then
					AddRowInTable(Table, "ICQ", ICQ)
				End If
				If ZodiacSign <> ZodiacalSymbols.Undefined Then
					AddRowInTable(Table, Phrase(Setting.Language, 3330), Phrase(Setting.Language, 3330 + ZodiacSign))
				End If
				If FamilySituation <> DatingManager.FamilySituation.Undefined Then
					AddRowInTable(Table, Phrase(Setting.Language, 3301), Phrase(Setting.Language, 3301 + FamilySituation))
				End If
				If Eyes <> EyesColor.Undefined Then
					AddRowInTable(Table, Phrase(Setting.Language, 3410), Phrase(Setting.Language, 3410 + Eyes))
				End If
				If Hair <> HairColor.Undefined Then
					AddRowInTable(Table, Phrase(Setting.Language, 3420), Phrase(Setting.Language, 3420 + Hair))
				End If
				If Height > 100 And Height < 220 Then
					AddRowInTable(Table, Phrase(Setting.Language, 3343), Height & " " & Phrase(Setting.Language, 3352))
				End If
				If Weight > 30 And Height < 250 Then
					AddRowInTable(Table, Phrase(Setting.Language, 3344), Weight & " " & Phrase(Setting.Language, 3350))
				End If
				If WebSite <> "" Then
					AddRowInTable(Table, Phrase(Setting.Language, 3026), WebSite)
				End If
				Return Ctrl
			End Function
			Private Sub AddRowInTable(ByVal Table As HtmlTable, ByVal Name As String, ByVal Value As String)
				Dim Row As New HtmlTableRow
				Table.Rows.Add(Row)
				Dim CellL As New HtmlTableCell
				'CellL.HorizontalAlign = HorizontalAlign.Right
				CellL.Style.Add("text-align", "right") 'html5
				Dim CellR As New HtmlTableCell
				Row.Cells.Add(CellL)
				Row.Cells.Add(CellR)
				Dim LabelL As New WebControls.Label
				LabelL.Text = Name
				LabelL.Style.Add("font-weight", "bold")
				CellL.Controls.Add(LabelL)
				Dim LabelR As New WebControls.Label
				LabelR.Text = Value
				CellR.Controls.Add(LabelR)
			End Sub
		End Class

		Enum Orientation
			Undefined
			Bisexual
			Homosexual
			Heterosexual
		End Enum

		Enum Relationship
			Undefined = 0
			Marriage = 2
			Friendship = 4
			Penpal = 8
			Serius = 16
			VirtualSex = 32
			PassionateLove = 64
			Adventure = 128
			SexService = 256
			Holiday = 512
			Sponsor = 1024
		End Enum

		Enum FamilySituation
			Undefined
			Married
			Marriageable
			Divorced
		End Enum

		Enum ZodiacalSymbols
			Undefined
			Aries
			Taurus
			Gemini
			Cancer
			Leo
			Virgo
			Libra
			Scorpio
			Sagittarius
			Capricorn
			Aquarius
			Pisces
		End Enum

		Enum EyesColor
			Undefined
			Green
			Blue
			Brown
			Gray
			Dark
			GrayBlue
		End Enum

		Enum HairColor
			Undefined
			Blonde
			Brown
			Dark
			Red
			Gray
		End Enum

		Enum Gender
			Indefinite
			Male
			Female
		End Enum

		Function FindPersons(ByVal MinOld As Integer, ByVal MaxOld As Integer, ByVal WithPhotos As Boolean, ByVal Gender As Gender, ByVal Relationship As Relationship, ByVal Orientation As Orientation) As Data.OleDb.OleDbDataReader
			'Dim Where As String = _
			'"Accommodation=" & Me.Index & _
			'" AND " & _
			'" annulled=false " & _
			'" AND NOT (" & _
			'"Arrival>=" & LastDate.ToString("#M/d/yyyy#") & _
			'" OR " & _
			'"Departure<=" & FirstDate.ToString("#M/d/yyyy#") & _
			'")"
			Dim MaxDate As Date = Now.AddYears(-MinOld)
			Dim MinDate As Date = Now.AddYears(-MaxOld - 1)
			Dim Culture As Globalization.CultureInfo = New Globalization.CultureInfo("en-US")
			Dim Where As String = _
			"Disabled=false AND " & _
			"(" & _
			"BirthYear>=" & MinDate.ToString("#M/d/yyyy#", Culture) & _
			" AND " & _
			"BirthYear<=" & MaxDate.ToString("#M/d/yyyy#", Culture) & _
			")"

			If WithPhotos Then
				Where &= " AND PhotoAlbum<>''"
			End If
			If Gender <> Gender.Indefinite Then
				Where &= " AND Gender=" & Gender
			End If
			If Relationship <> DatingManager.Relationship.Undefined Then
				'Where &= " AND (TypeOfRelationship BAND " & Relationship & ") <> 0" 'This routine work with Microsoft Jet 4.0
				'Where &= " AND (TypeOfRelationship & " & Relationship & ") <> 0" 'This routine not work!
				'Where &= " AND (int(TypeOfRelationship) & int(" & Relationship & ")) <> 0" 'This routine not work!
				Where &= " AND (" & AndBitForBit(Relationship) & ")" 'This routene work OK but is slow
			End If
			If Orientation <> DatingManager.Orientation.Undefined Then
				Where &= " AND (Orientation=0 OR Orientation=" & Orientation & ")"
			End If

			Return DataManager.Table(DatingDataFile, "Persons", Where, "ID", True, Data.CommandBehavior.CloseConnection)
		End Function

		Private Function AndBitForBit(ByVal Relationship As Integer) As String
			Dim SQL As String
			Dim Base() As Integer = {Relationship}
			Dim Bites As New BitArray(Base)
			For N As Integer = 0 To Bites.Count - 1
				If Bites(N) Then
					If SQL <> "" Then
						SQL &= " OR"
					End If
					Dim BiteValue As Integer = 2 ^ N
					SQL &= " (TypeOfRelationship\" & BiteValue & ") mod 2 = 1"
				End If
			Next
			Return SQL
		End Function

	End Module
End Namespace