﻿'© By Andrea Bruno
'Open source, but: This source code (or part of this code) is not usable in other applications

Imports System.Text
Imports System.Security.Cryptography

Namespace WebApplication


	Public Module Crc


		Private Function GenerateHash(ByVal SourceText As String) As String
			'Create an encoding object to ensure the encoding standard for the source text
			Dim Ue As New UnicodeEncoding()
			'Retrieve a byte array based on the source text
			Dim ByteSourceText() As Byte = Ue.GetBytes(SourceText)
			'Instantiate an MD5 Provider object
			Dim Md5 As New HMACRIPEMD160
			'Compute the hash value from the source
			Dim ByteHash() As Byte = Md5.ComputeHash(ByteSourceText)
			'And convert it to String format for return
			Return Convert.ToBase64String(ByteHash)
		End Function




		'======================================================================================
		'======================================================================================

		Private hexcase As UInteger = 0UI	 '  hex output format. 0 - lowercase 1 - uppercase        ' 
		Private b64pad As String = ""	'  base-64 pad character. "=" for strict RFC compliance   ' 
		Private chrsz As UInteger = 8UI	 '  bits per input character. 8 - ASCII 16 - Unicode      ' 

		Function Ed2KcodeFromWeb(ByVal Data As Byte())
			'Set values for the request back

			Dim Url As String = "http://www.webutils.pl/index.php?idx=md5"
			Dim req As System.Net.HttpWebRequest = CType(System.Net.WebRequest.Create(Url), System.Net.HttpWebRequest)

			req.Method = "POST"
			req.ContentType = "application/x-www-form-urlencoded"
			Dim Param() As Byte	'= HttpContext.Current.Request.BinaryRead(HttpContext.Current.Request.ContentLength)
			Dim strRequest As String '= Encoding.ASCII.GetString(Param)
			'strRequest = strRequest + "&cmd=_notify-validate"
			strRequest = "mode=all"
			req.ContentLength = strRequest.Length

			'Send the request to Website and get response
			Dim streamOut As System.IO.StreamWriter = New System.IO.StreamWriter(req.GetRequestStream(), Encoding.ASCII)
			streamOut.Write(strRequest)
			streamOut.Close()
			Dim streamIn As System.IO.StreamReader = New System.IO.StreamReader(req.GetResponse().GetResponseStream())
			Dim strResponse As String = streamIn.ReadToEnd()
			streamIn.Close()

			If strResponse = "VERIFIED" Then
				'check the payment_status is Completed
				'check that txn_id has not been previously processed
				'check that receiver_Email is your Primary PayPal Email
				'check that payment_amount/payment_currency are correct
				'process payment
				Return True
			ElseIf strResponse = "INVALID" Then
				'log for manual investigation
			Else
				'Response wasn't VERIFIED or INVALID, log for manual investigation
			End If

		End Function



		Function Ed2kCrc(ByVal data As String) As String
			Const LenBlock As UInteger = 9728000
			Dim Result As String
			For P As UInteger = 0 To Len(data) Step LenBlock
				Result &= hex_md4(Left(data.Substring(P), LenBlock))
			Next
			If Len(Result) > 32 Then
				Dim Str As String
				For N As UInteger = 1 To Len(Result) Step 2
					Str &= Chr(Val("&h" & Mid(Result, N, 2)))
				Next
				Return hex_md4(Str)
			Else
				Return Result
			End If
		End Function


		' 
		'  These are the functions you'll usually want to call
		' 
		Function hex_md4(ByVal s As String) As String
			Return UIntegerArray2Hex(core_md4(str2binl(s), s.Length * chrsz))
		End Function

		Private Function UIntegerArray2Hex(ByVal UIntegers As Collections.Generic.Dictionary(Of UInteger, UInteger)) As String
			For N As UInteger = 0 To UIntegers.Count - 1
				Dim hx As String = Right("00000000" & Hex(UIntegers(N)), 8)
				UIntegerArray2Hex &= hx.Substring(6, 2) & hx.Substring(4, 2) & hx.Substring(2, 2) & hx.Substring(0, 2)
			Next
		End Function


		Function hex_hmac_md4(ByVal key, ByVal data) As String
			Return UIntegerArray2Hex(core_hmac_md4(key, data))
		End Function

		'  
		'  Perform a simple self-test to see if the VM is working 
		' 
		Sub md4_test()
			Dim x As Integer = StrComp(hex_md4("The quick brown fox jumps over the lazy dog"), "1bee69a46ba811185c194762abaeae90", CompareMethod.Text)
			Stop
		End Sub

		' 
		'  Calculate the MD4 of an array of little-endian words, and a bit length
		' 
		Function core_md4(ByVal x As Collections.Generic.Dictionary(Of UInteger, UInteger), ByVal len As UInteger) As Collections.Generic.Dictionary(Of UInteger, UInteger)
			'  append padding ' 
			AddOr(x, len >> 5UI, &H80UI << (len Mod 32UI))
			x.Add((((len + 64UI) >> 9UI) << 4UI) + 14UI, len)

			Dim a As UInteger = 1732584193UI
			Dim b As UInteger = 4023233417UI 'BitesUintToInt32(-271733879)
			Dim c As UInteger = 2562383102UI 'BitesUintToInt32(-1732584194)
			Dim d As UInteger = 271733878UI

			For i As UInteger = 0 To x.Count - 1 Step 16UI
				Dim olda As UInteger = a
				Dim oldb As UInteger = b
				Dim oldc As UInteger = c
				Dim oldd As UInteger = d

				a = md4_ff(a, b, c, d, ValueX(x, i + 0UI), 3UI)
				d = md4_ff(d, a, b, c, ValueX(x, i + 1UI), 7UI)
				c = md4_ff(c, d, a, b, ValueX(x, i + 2UI), 11UI)
				b = md4_ff(b, c, d, a, ValueX(x, i + 3UI), 19UI)
				a = md4_ff(a, b, c, d, ValueX(x, i + 4UI), 3UI)
				d = md4_ff(d, a, b, c, ValueX(x, i + 5UI), 7UI)
				c = md4_ff(c, d, a, b, ValueX(x, i + 6UI), 11UI)
				b = md4_ff(b, c, d, a, ValueX(x, i + 7UI), 19UI)
				a = md4_ff(a, b, c, d, ValueX(x, i + 8UI), 3UI)
				d = md4_ff(d, a, b, c, ValueX(x, i + 9UI), 7UI)
				c = md4_ff(c, d, a, b, ValueX(x, i + 10UI), 11UI)
				b = md4_ff(b, c, d, a, ValueX(x, i + 11UI), 19UI)
				a = md4_ff(a, b, c, d, ValueX(x, i + 12UI), 3UI)
				d = md4_ff(d, a, b, c, ValueX(x, i + 13UI), 7UI)
				c = md4_ff(c, d, a, b, ValueX(x, i + 14UI), 11UI)
				b = md4_ff(b, c, d, a, ValueX(x, i + 15UI), 19UI)

				a = md4_gg(a, b, c, d, ValueX(x, i + 0UI), 3UI)
				d = md4_gg(d, a, b, c, ValueX(x, i + 4UI), 5UI)
				c = md4_gg(c, d, a, b, ValueX(x, i + 8UI), 9UI)
				b = md4_gg(b, c, d, a, ValueX(x, i + 12UI), 13UI)
				a = md4_gg(a, b, c, d, ValueX(x, i + 1UI), 3UI)
				d = md4_gg(d, a, b, c, ValueX(x, i + 5UI), 5UI)
				c = md4_gg(c, d, a, b, ValueX(x, i + 9UI), 9UI)
				b = md4_gg(b, c, d, a, ValueX(x, i + 13UI), 13UI)
				a = md4_gg(a, b, c, d, ValueX(x, i + 2UI), 3UI)
				d = md4_gg(d, a, b, c, ValueX(x, i + 6UI), 5UI)
				c = md4_gg(c, d, a, b, ValueX(x, i + 10UI), 9UI)
				b = md4_gg(b, c, d, a, ValueX(x, i + 14UI), 13UI)
				a = md4_gg(a, b, c, d, ValueX(x, i + 3UI), 3UI)
				d = md4_gg(d, a, b, c, ValueX(x, i + 7UI), 5UI)
				c = md4_gg(c, d, a, b, ValueX(x, i + 11UI), 9UI)
				b = md4_gg(b, c, d, a, ValueX(x, i + 15UI), 13UI)

				a = md4_hh(a, b, c, d, ValueX(x, i + 0UI), 3UI)
				d = md4_hh(d, a, b, c, ValueX(x, i + 8UI), 9UI)
				c = md4_hh(c, d, a, b, ValueX(x, i + 4UI), 11UI)
				b = md4_hh(b, c, d, a, ValueX(x, i + 12UI), 15UI)
				a = md4_hh(a, b, c, d, ValueX(x, i + 2UI), 3UI)
				d = md4_hh(d, a, b, c, ValueX(x, i + 10UI), 9UI)
				c = md4_hh(c, d, a, b, ValueX(x, i + 6UI), 11UI)
				b = md4_hh(b, c, d, a, ValueX(x, i + 14UI), 15UI)
				a = md4_hh(a, b, c, d, ValueX(x, i + 1UI), 3UI)
				d = md4_hh(d, a, b, c, ValueX(x, i + 9UI), 9UI)
				c = md4_hh(c, d, a, b, ValueX(x, i + 5UI), 11UI)
				b = md4_hh(b, c, d, a, ValueX(x, i + 13UI), 15UI)
				a = md4_hh(a, b, c, d, ValueX(x, i + 3UI), 3UI)
				d = md4_hh(d, a, b, c, ValueX(x, i + 11UI), 9UI)
				c = md4_hh(c, d, a, b, ValueX(x, i + 7UI), 11UI)
				b = md4_hh(b, c, d, a, ValueX(x, i + 15UI), 15UI)

				a = safe_add(a, olda)
				b = safe_add(b, oldb)
				c = safe_add(c, oldc)
				d = safe_add(d, oldd)

			Next
			Dim Array As New Collections.Generic.Dictionary(Of UInteger, UInteger) ' = {a, b, c, d}
			Array.Add(0UI, a)
			Array.Add(1UI, b)
			Array.Add(2UI, c)
			Array.Add(3UI, d)

			Return Array

		End Function

		Function BitesUintToInt32(ByVal Input As Integer) As UInteger
			Return Hex(Input)
			Dim I(0) As Integer
			I(0) = Input
			Dim A As New Collections.BitArray(I)
			Dim O(0) As UInteger
			A.CopyTo(O, 0)
			Return O(0)
		End Function


		Private Function ValueX(ByVal x As Collections.Generic.Dictionary(Of UInteger, UInteger), ByVal Index As UInteger) As UInteger
			If x.ContainsKey(Index) Then
				Return x(Index)
			Else
				Return 0UI
			End If
		End Function


		' 
		'  These functions implement the basic operation for each round of the
		'  algorithm.
		' 
		Function md4_cmn(ByVal q As UInteger, ByVal a As UInteger, ByVal b As UInteger, ByVal x As UInteger, ByVal s As UInteger, ByVal t As UInteger) As UInteger
			Return safe_add(rol(safe_add(safe_add(a, q), safe_add(x, t)), s), b)
		End Function
		Function md4_ff(ByVal a As UInteger, ByVal b As UInteger, ByVal c As UInteger, ByVal d As UInteger, ByVal x As UInteger, ByVal s As UInteger) As UInteger
			Return md4_cmn((b And c) Or ((Not b) And d), a, 0, x, s, 0)
		End Function
		Function md4_gg(ByVal a As UInteger, ByVal b As UInteger, ByVal c As UInteger, ByVal d As UInteger, ByVal x As UInteger, ByVal s As UInteger) As UInteger
			Return md4_cmn((b And c) Or (b And d) Or (c And d), a, 0, x, s, 1518500249)
		End Function
		Function md4_hh(ByVal a As UInteger, ByVal b As UInteger, ByVal c As UInteger, ByVal d As UInteger, ByVal x As UInteger, ByVal s As UInteger) As UInteger
			Return md4_cmn(b Xor c Xor d, a, 0, x, s, 1859775393)
		End Function

		' 
		'  Calculate the HMAC-MD4, of a key and some data
		' 
		Function core_hmac_md4(ByVal key, ByVal data) As Collections.Generic.Dictionary(Of UInteger, UInteger)
			Dim bkey As Collections.Generic.Dictionary(Of UInteger, UInteger) = str2binl(key)
			If (bkey.Count > 16) Then
				bkey = core_md4(bkey, key.length * chrsz)
			End If
			Dim ipad(15) As UInteger
			Dim opad(15) As UInteger
			For i As UInteger = 0UI To 15UI
				ipad(i) = bkey(i) Xor &H36363636
				opad(i) = bkey(i) Xor &H5C5C5C5C
			Next

			Dim S2B As Collections.Generic.Dictionary(Of UInteger, UInteger) = str2binl(data)
			ReDim Preserve ipad(15 + S2B.Count)
			'S2B.CopyTo(ipad, 16)
			'Dim hash As UInteger() = core_md4(S2B, 512 + data.length * chrsz)

			'ReDim Preserve opad(15 + hash.Length)
			'hash.CopyTo(opad, 16)
			'Return core_md4(opad, 512 + 128)
		End Function

		' 
		'  Add UIntegers, wrapping at 2 Xor 32. This uses 16-bit operations internally
		'  to work around bugs in some JS interpreters.
		' 
		Function safe_add(ByVal x As UInteger, ByVal y As UInteger) As UInteger
			Dim lsw As UInteger = (x And &HFFFF) + (y And &HFFFF)
			Dim msw As UInteger = (x >> 16UI) + (y >> 16UI) + (lsw >> 16UI)
			Return (msw << 16UI) Or (lsw And &HFFFF)
		End Function

		' 
		'  Bitwise rotate a 32-bit number to the left.
		' 

		Function rol(ByVal num As UInteger, ByVal cnt As UInteger) As UInteger
			Return (num << cnt) Or (num >> (32UI - cnt))

			'      Dim ArNum(0) As UInteger
			'      ArNum(0) = num
			'      Dim ar As New Collections.BitArray(ArNum)
			'      Dim arres As New Collections.BitArray(32)
			'      For Id As UInteger = 0 To 31
			' Dim NewId As UInteger = ((Id + cnt) Mod 32)
			' arres.Set(NewId, ar(Id))
			' Next
			'
			'      Dim resa(0) As UInteger
			'      arres.CopyTo(resa, 0)
			'      Dim Res As UInteger = resa(0)
			'      Return Res


		End Function

		' 
		'  Convert a string to an array of little-endian words
		'  If chrsz is ASCII, characters >255 have their hi-byte silently ignored.
		' 
		Function str2binl(ByVal str As String) As Collections.Generic.Dictionary(Of UInteger, UInteger)
			Dim bin As New Collections.Generic.Dictionary(Of UInteger, UInteger)
			Dim mask As UInteger = (1UI << chrsz) - 1UI
			If str <> "" Then
				For i As UInteger = 0UI To Len(str) * chrsz - 1 Step chrsz
					AddOr(bin, i >> 5UI, (Microsoft.VisualBasic.AscW(str.Chars(i / chrsz)) And mask) << (i Mod 32UI))
				Next
			End If
			Return bin
		End Function

		Private Sub AddOr(ByVal Array As Collections.Generic.Dictionary(Of UInteger, UInteger), ByVal Index As UInteger, ByVal Value As UInteger)
			Dim NewValue As UInteger
			If Array.ContainsKey(Index) Then
				Array(Index) = Array(Index) Or Value
			Else
				Array.Add(Index, Value)
			End If
		End Sub

	End Module


End Namespace
