Imports WebApplication

Partial Class MasterPageModel
  Inherits WebApplication.Components.MasterPage
  Shared CodeClickToSearch As String
  Public TitlePage As String
  Private m_UseGoogleOff As Boolean = Setup.SEO.GoogleOffGoogleOnTagsEnabled
  Private m_AdSenseDisabled As Boolean
  Private m_Description As String
  Private m_Author As String
  Private m_KeyWords As String
  Private m_Language As String
  Private m_MetaRevisitAfterDays As Integer = Config.MetaRevisitAfterDays
  Private TraceControls() As Control
  Private RobotsOff As Boolean
  Private AuthorOff As Boolean
  Private NoArchive As Boolean

  Public Overrides Property Setting() As SubSite
  Public Overrides Property User As WebApplication.User = WebApplication.CurrentUser
  Public Overrides Property Rating As Integer

  Public Overrides Property UseGoogleOff() As Boolean
    Get
      Return m_UseGoogleOff
    End Get
    Set(ByVal value As Boolean)
      m_UseGoogleOff = value
    End Set
  End Property

  'Overrides
  Public Overrides Property AdSenseDisabled() As Boolean
    Get
      Return m_AdSenseDisabled
    End Get
    Set(ByVal value As Boolean)
      m_AdSenseDisabled = value
    End Set
  End Property

  Public Overrides Function AddButton(ByVal Text As String, ByVal Href As String, Optional ByVal ToolTip As String = Nothing, Optional ByVal Icon As IconType = Nothing, Optional ByVal Target As TargetForButton = TargetForButton.Self, Optional ByVal Nofollow As Boolean = False, Optional ByVal OnClick As String = Nothing, Optional Blink As Boolean = False) As WebControl
    Return ToolsBarAddButton(ToolsBar, Text, Href, ToolTip, Icon, Target, Nofollow, OnClick, Blink)
  End Function

  Public Overrides Sub AddButton(ByVal Button As ButtonsStandard, Optional Blink As Boolean = False)
    Select Case Button
      Case ButtonsStandard.NewPage
        Me.AddButton(Phrase(Setting.Language, 3013), Href(Setting.Name, False, "edit.aspx"), , Components.IconType.DocumentBlank, , True, , Blink)
      Case ButtonsStandard.PageManager
        Me.AddButton(Phrase(Setting.Language, 3018), Href(Setting.Name, False, "pagesmanager.aspx"), , Components.IconType.ControlPanel, , True, , Blink)
    End Select
  End Sub

  Public Overrides Sub ShowElement(Optional ByRef LeftBar As Boolean = True, Optional ByRef RightBar As Boolean = True, Optional ByRef TopBar As Boolean = True, Optional ByRef BottomBar As Boolean = True)
    ShowLeftBar = LeftBar
    ShowRightBar = RightBar
    ShowTopBar = TopBar
    ShowBottomBar = BottomBar
  End Sub

  Public Overrides Property ContentPlaceHolder() As WebControls.ContentPlaceHolder
    Get
      Return ContentPlaceHolder1
    End Get
    Set(ByVal Value As WebControls.ContentPlaceHolder)
      ContentPlaceHolder1 = Value
    End Set
  End Property

  Public Overrides ReadOnly Property MainContainer As Control
    Get
      Return Container
    End Get
  End Property

  Public Overrides ReadOnly Property UserToolsBar As Control
    Get
      Return ToolsBar
    End Get
  End Property

  Private CollectionOfBottomContent As New Collections.Generic.List(Of BottomContent)

  Public Overrides ReadOnly Property BottomContentCollection As Collections.Generic.List(Of BottomContent)
    Get
      Return CollectionOfBottomContent
    End Get
  End Property

  Public Overrides Sub AddBottomContent(ByVal Bar As Control, ByVal Canonical As String)
    Dim BottonContent As New BottomContent
    BottonContent.Bar = Bar
    BottonContent.Canonical = Canonical
    CollectionOfBottomContent.Add(BottonContent)
  End Sub

  Public Overrides ReadOnly Property Left As Control
    Get
      Return BarLeft
    End Get
  End Property

  Public Overrides ReadOnly Property Top As Control
    Get
      Return BarTop
    End Get
  End Property

  Public Overrides ReadOnly Property TopToLeft As Control
    Get
      Return Me.TopLeft
    End Get
  End Property

  Public Overrides ReadOnly Property TopToRight As Control
    Get
      Return Me.TopRight
    End Get
  End Property

  Public Overrides ReadOnly Property Right As Control
    Get
      Return BarRight
    End Get
  End Property
  Public Overrides ReadOnly Property Bottom As Control
    Get
      Return BarBottom
    End Get
  End Property


  Public Overrides Property ShowTopBar() As Boolean
    Get
      ShowTopBar = BarTop.Visible
    End Get
    Set(ByVal Value As Boolean)
      BarTop.Visible = Value
    End Set
  End Property

  Public Overrides Property ShowBottomBar() As Boolean
    Get
      ShowBottomBar = BarBottom.Visible
    End Get
    Set(ByVal Value As Boolean)
      BarBottom.Visible = Value
    End Set
  End Property

  Public Overrides Property ShowLeftBar() As Boolean
    Get
      ShowLeftBar = BarLeft.Visible
    End Get
    Set(ByVal Value As Boolean)
      BarLeft.Visible = Value
    End Set
  End Property

  Public Overrides Property ShowRightBar() As Boolean
    Get
      ShowRightBar = BarRight.Visible
    End Get
    Set(ByVal Value As Boolean)
      BarRight.Visible = Value
    End Set
  End Property

  Public Overrides Property ShowMenu() As Boolean
    Get
      ShowMenu = BarLeft.Visible
    End Get
    Set(ByVal Value As Boolean)
      BarLeft.Visible = Value
    End Set
  End Property

  Public Overrides Property ShowMeteo() As Boolean
    Get
      ShowMeteo = BarLeft.Visible
    End Get
    Set(ByVal Value As Boolean)
      BarLeft.Visible = Value
    End Set
  End Property

  Public Overrides Property Author() As String
    Get
      Return m_Author
    End Get
    Set(ByVal value As String)
      m_Author = value
    End Set
  End Property
  Public Overrides Property MetaRevisitAfterDays() As Integer
    Get
      Return m_MetaRevisitAfterDays
    End Get
    Set(ByVal value As Integer)
      m_MetaRevisitAfterDays = value
    End Set
  End Property
  Public Overrides Property Description() As String
    Get
      Return m_Description
    End Get
    Set(ByVal value As String)
      m_Description = value
    End Set
  End Property
  Public Overrides Property KeyWords() As String
    Get
      Return m_KeyWords
    End Get
    Set(ByVal value As String)
      m_KeyWords = value
    End Set
  End Property
  Public Overrides Property Language() As String
    Get
      Return m_Language
    End Get
    Set(ByVal value As String)
      m_Language = value
    End Set
  End Property
  Public Overrides Property ShortcutIcon() As String
    Get
      Return FavIcon.Href
    End Get
    Set(ByVal value As String)
      FavIcon.Href = value
    End Set
  End Property
  Public Overrides Property Style() As String
    Get
      Return StyleMaster.InnerText
    End Get
    Set(ByVal value As String)
      StyleMaster.InnerText = value
    End Set
  End Property
  Public Overrides Property TitleDocument() As String
    Get
      Return HttpUtility.HtmlDecode(Page.Title)
    End Get
    Set(ByVal value As String)
      Page.Title = HttpUtility.HtmlEncode(value)
    End Set
  End Property

  Private Services As New HtmlGenericControl("nav") 'Html5

  Private AuthostInThisPage As New Collections.Generic.List(Of WebApplication.User)
  Public Overrides ReadOnly Property Authors As Collections.Generic.List(Of WebApplication.User)
    Get
      SyncLock AuthostInThisPage
        Return AuthostInThisPage
      End SyncLock
    End Get
  End Property
  Public Overrides Sub AddAuthors(Author As User)
    SyncLock AuthostInThisPage
      If Not AuthostInThisPage.Contains(Author) Then
        AuthostInThisPage.Add(Author)
      End If
    End SyncLock
  End Sub

  Public Overrides Sub AddItemService(ByVal Href As String, ByVal Text As String, ByVal ToolTip As String, Optional ByVal Level As Integer = 2)
    Services.Controls.Add(ControlItem(Href, Text, ToolTip, Level))
  End Sub

  Private Sub SetElements(ByVal Setting As WebApplication.SubSite)
    'Auto login
    'WebApplication.TryAutoLogin()
    'Dim Mobile As Boolean = HttpContext.Current.Request.Browser.IsMobileDevice
    Dim Skin As WebApplication.Skin = Setting.Skin
    Dim SkinSetup As SkinSetup = Setting.Skin.SkinSetup

    If SkinSetup IsNot Nothing Then
      Dim CounterRequest = Session("CounterRequest")
      If CounterRequest Is Nothing Then
        CounterRequest = 1
        Session("CounterRequest") = 2
      Else
        Session("CounterRequest") += 1
      End If
      Dim BgSound As String = SkinSetup.Variables("bgsound")
      If BgSound <> "" AndAlso ((Not StrComp(SkinSetup.Variables("soundonlyatstartsession"), "true", CompareMethod.Text) = 0) OrElse CounterRequest = 1) Then
        'If Not IsLocal() Then
        If BgSound.EndsWith(".mod") Then
          'Me.Page.Header.Controls.Add(ModPLayer)
          'Dim MasterPage As Components.MasterPage = Page.Master
          'MasterPage.Controls.AddAt(4, ModPLayer)
          BarTop.Controls.AddAt(0, ModPLayer)
          'Me.Page.Header.Controls.Add(FlashControl(FlashResources & "/BitboyApp.swf"))
        ElseIf Request.Browser.BackgroundSounds Then
          Dim SoundCtrl As New WebControls.WebControl(HtmlTextWriterTag.Bgsound)
          SoundCtrl.Attributes.Add("src", BgSound)
          Me.Page.Header.Controls.Add(SoundCtrl)
        Else
          Me.form1.Controls.AddAt(0, AudioObject(SkinSetup.Variables("BgSound")))
        End If
        'End If 
      End If
    End If

    If TraceControls IsNot Nothing Then
      'Add trace menu at top page, ex: Rome > History > Foundation
      Dim LastId As Integer = TraceControls.GetUpperBound(0)
      For N As Integer = 0 To LastId
        NavigationScheme.Controls.Add(TraceControls(N))
        If N <> LastId Then
          Dim Space As New LiteralControl(" > ")
          NavigationScheme.Controls.Add(Space)
        End If
      Next
    End If

    'Add elements at end of page
    If IsCrawler(Request) Then
      AddCodeFromFile(BarBottom, "HideContent")
    End If

    If Config.Setup.RenderingEngine.AddLinksDomains AndAlso BarBottom.Visible = True Then
      AddLinksDomains(Config.Setup.RenderingEngine.HideLinksDomains)    ' Add friend domains to best ranking"
    End If

    If Not WebApplication.IsLocal() Then
      AddCodeCounter()
    End If


    Dim HomePage As String
    Dim DomainConfiguration As DomainConfiguration = CurrentDomainConfiguration()
    HomePage = WebApplication.Common.Href(Setting.Name, False, "default.aspx")

    If BarLeft.Visible Then

      'Add link to services
      For Each Plugin As PluginManager.Plugin In AllPlugins()
        If Plugin.AddItemToMenu Then
          If Plugin.IsEnabledAndAccessible(User, Setting) Then
            AddItemService(Href(Setting.Name, False, Plugin.AspxFileName), Plugin.Description(Setting.Language, True), Plugin.Description(Setting.Language, False))
          End If
        End If
      Next

      If Services.Controls.Count Then
        Services.Controls.AddAt(0, ControlItem(Nothing, WebApplication.Phrase(Setting.Language, 0), WebApplication.Phrase(Setting.Language, 0), 0))
        Services.Attributes("class") = "Menu"
        BarLeft.Controls.Add(Services)
      Else
        Services.Dispose()
      End If

      'Add menu
      BarLeft.Controls.Add(WebApplication.MenuControls(CurrentDomainConfiguration, Setting))

      'Add link to blog
      If Setting.Blog IsNot Nothing AndAlso Setting.Blog.Count > 0 Then
        Dim BlogLinks As New WebControl(HtmlTextWriterTag.Div)
        BlogLinks.CssClass = "Menu"
        BlogLinks.Controls.Add(ControlItem(Nothing, "web", Nothing, 0))

        For Each Blog As Notice In Setting.Blog
          Dim Href As String
          If UrlPointToThisNetwork(Blog.Link) Then
            Href = Blog.Link
          Else
            Href = Common.Href(CurrentSetting.Name, False, "default.aspx", "s", DefaultPageShowType.ExternalPage, "u", Blog.Link.Substring(Blog.Link.IndexOf("/"c) + 2))
          End If
          BlogLinks.Controls.Add(ControlItem(Href, InnerText(Blog.Title), InnerText(Blog.Description)))
        Next
        BarLeft.Controls.Add(BlogLinks)
      End If

      If Not Setting.Weathers Is Nothing Then
        BarLeft.Controls.Add(WebApplication.Weathers(Setting))
      End If

      'Add Currency Exchange Table
      If Setting.CurrencyExchangeWidget Then
        BarLeft.Controls.Add(WebApplication.CurrencyManager.ExchangeTable(Setting.Currency, Setting.Language, Skin))
      End If

      AddCodeFromFile(BarLeft)
    End If

    If BarRight.Visible Then
      'Add random foto preview
      If Setting.Photoalbums IsNot Nothing Then
        Dim Added As Boolean
        Dim Random As Random
        If User.GeneralRole = Authentication.User.RoleType.Visitors Then
          Random = StringToRandom(Setting.Name & Request.Url.PathAndQuery)
        End If
        For Each PhotoAlbum As String In Setting.Photoalbums
          Dim Exclude As Collections.Generic.List(Of Integer) = New Collections.Generic.List(Of Integer)
          Dim Photos As Collections.Generic.List(Of Photo) = GetRandomPhotos(PhotoAlbum, Setting.Aspect.RandomPicturesForPhotoAlbum)
          For Each Photo In Photos
            BarRight.Controls.Add(Photo.ControlThumbnail(Setting))
          Next
          If Photos.Count Then Added = True
        Next
        If Added Then
          BarRight.Controls.Add(BR)
        End If
      End If
      AddCodeFromFile(BarRight)

      'Add search results restrict to this domain
      If Setting.ShowRelatedPagesWithTheSearchCarriedOutByTheVisitor Then
        If Session("QuerySearch") <> "" Then
          If Session("ResultOfSearchControl") Is Nothing Then
            Dim Control As Control = SeacrhResult(Session("QuerySearch"), CurrentDomain)
            If Control Is Nothing Then
              Session("ResultOfSearchControl") = False
            Else
              Session("ResultOfSearchControl") = Control
            End If
          End If
          If Not TypeOf (Session("ResultOfSearchControl")) Is Boolean Then
            ContentPlaceHolder.Controls.Add(Session("ResultOfSearchControl"))
          End If
        End If
      End If
    End If

    If BarTop.Visible Then
      If Not SkinSetup Is Nothing Then
        Dim TitleDescription As String = Trim(Setting.Title & " " & Setting.Description)
        Dim ImageTopLeft As String = SkinSetup.Variables("ImageTopLeft")

        Dim LinkLogo As String
        If User.GeneralRole >= Authentication.User.RoleType.User Then
          LinkLogo = User.Href(Setting)
        Else
          LinkLogo = HomePage
        End If

        If ImageTopLeft <> "" Then
          Dim CtrlTopLeft As Control = WebApplication.ControlSkin(ImageTopLeft, TitleDescription, LinkLogo)
          If CtrlTopLeft IsNot Nothing Then
            Dim WebControl As WebControl = CtrlTopLeft
            WebControl.CssClass = "ImageTopLeft"
            TopLeft.Controls.AddAt(0, WebControl)
          End If
        End If

        Dim Logo As String = SkinSetup.Variables("Logo")
        If Logo <> "" Then
          Dim CtrlLogo As Control = WebApplication.ControlSkin(Logo, TitleDescription, LinkLogo)
          If CtrlLogo IsNot Nothing Then
            Dim WebControl As WebControl = CtrlLogo
            WebControl.CssClass = "Logo"
            TopLeft.Controls.Add(WebControl)
          End If
        End If

        If Setting.Title <> "" Then
          'Add web-site title
          Dim Title As New Label
          Title.CssClass = "WebSiteTitle"
          Dim Size As Integer = 1200 / Setting.Title.Length
          If Size > 50 Then Size = 50
          If Size < 15 Then Size = 15
          Title.Font.Size = New WebControls.FontUnit(Size, UnitType.Pixel)
          Title.Text = HttpUtility.HtmlEncode(Setting.Title)
          TopLeft.Controls.Add(Title)
        End If

        Dim BannerServices As String = SkinSetup.Variables("BannerServices")
        If BannerServices <> "" Then
          If True Then
            'Services mini-banner
            AddTopMiniBanner(BannerServices, Phrase(Setting.Language, 0), WebApplication.Common.Href(Setting.Name, False, "contact.aspx"))
          End If
        End If

        'Add link and flag for multylanguage web site
        If DomainConfiguration.SubSitesAvailable.Count > 1 Then
          If Not DomainConfiguration.AvailableAllSubSite Then
            'Add SubSite Index for this url
            For Each SubSite As WebApplication.SubSite In DomainConfiguration.SubSites
              If SubSite.Name <> Setting.Name Then
                'Add flag
                Dim Flag As HtmlImage = Components.Flag(SubSite.Language)
                Flag.Attributes.Add("class", "Flag")
                'Add link
                Dim Link As New WebControls.HyperLink
                Link.Attributes.Add("title", EncodingAttribute(SubSite.Title))
                Link.Controls.Add(Flag)
                Link.NavigateUrl = WebApplication.Common.Href(SubSite.Name, False, "default.aspx")
                TopRight.Controls.Add(Link)
              End If
            Next
          End If
        End If

        'Button Home Page
        Dim HomePageButtonText As String
        Dim TooltipHomePageButton As String = WebApplication.Phrase(Setting.Language, 4)
        If Setting.SEO.TextOnHomePageButton = SubSite.SeoFunctions.HomeButtonText.WebsiteTitle AndAlso Setting.Title <> "" Then
          HomePageButtonText = Setting.Title
        Else
          HomePageButtonText = TooltipHomePageButton
        End If
        AddButton(HomePageButtonText, HomePage, TooltipHomePageButton, WebApplication.Components.IconType.Home)

        If User.GeneralRole >= WebApplication.User.RoleType.User Then
          'Button HomeUser
          Dim Button As Control = AddButton(WebApplication.Phrase(Setting.Language, 34) & " " & User.Username, User.Href(Setting), , WebApplication.Components.IconType.MyIcons)
          AddFotoAlbumSlideShow(Setting, Button, User.NamePhotoAlbum)
        Else
          'Button New User
          Dim IsDefault As Boolean = Setting.Name = SubSite.DefaultSiteConfiguration
          If Not IsDefault Then
            If Request.AppRelativeCurrentExecutionFilePath <> "~/log.aspx" OrElse Request.QueryString("a") <> CStr(LogActionType.NewUser) Then
              Dim Href As String = WebApplication.HrefLogin
              AddButton(WebApplication.Phrase(Setting.Language, 20), Href, , WebApplication.Components.IconType.Favourites, , True, , Setting.Aspect.SuggestTheBestChoiceByTheBlink)
            End If
          End If

          'Button LogIn/Off																																
          If Request.AppRelativeCurrentExecutionFilePath <> "~/log.aspx" OrElse Request.QueryString("a") <> "" Then
            Dim Href As String = WebApplication.HrefLogin(False)
            Dim Blink As Boolean
            If IsDefault Then
              Blink = Setting.Aspect.SuggestTheBestChoiceByTheBlink
            End If
            AddButton(WebApplication.Phrase(Setting.Language, 21), Href, , WebApplication.Components.IconType.Favourites, , True, , Blink)
          End If
        End If

        'Button Online Users
        If Setting.UsersOnline Then
          AddButton(Phrase(Setting.Language, 131), WebApplication.Common.Href(Setting.Name, False, "default.aspx", "s", DefaultPageShowType.OnlineUsers), , WebApplication.Components.IconType.Users, , True)
        End If

        If Setting.Forums IsNot Nothing Then
          'Add button Forum
          AddButton(WebApplication.Phrase(Setting.Language, 61), WebApplication.Common.Href(Setting.Name, False, "forum.aspx"), , WebApplication.Icon_Forum)
        End If

        If Setting.News IsNot Nothing AndAlso Setting.News.SourcesRSS IsNot Nothing AndAlso Setting.News.SourcesRSS.Count Then
          'Add button News
          AddButton(WebApplication.Phrase(Setting.Language, 2), WebApplication.Common.Href(Setting.Name, False, "default.aspx", "s", DefaultPageShowType.News), , WebApplication.Components.IconType.Globe)
        End If

        'Button show PhotoAlbum
        If HttpContext.Current.Request.Url.LocalPath.EndsWith("/default.aspx", StringComparison.InvariantCultureIgnoreCase) Then
          If Setting.Photoalbums IsNot Nothing AndAlso Setting.Photoalbums.Count <> 0 Then
            Dim Href As String
            If Setting.Photoalbums.Count = 1 Then
              Href = WebApplication.Common.Href(Setting.Name, False, "thumbnails.aspx", "album", Setting.Photoalbums(0))
            Else
              Href = WebApplication.Common.Href(Setting.Name, False, "default.aspx", "s", DefaultPageShowType.ListPhotoAlbum)
            End If
            Dim Button As Control = AddButton(WebApplication.Phrase(Setting.Language, 103), Href, , WebApplication.Components.IconType.FolderPics)
            AddFotoAlbumSlideShow(Setting, Button, Setting.Photoalbums(0))
          End If
        End If

        'Button Contact
        If Setting.Contacts Then
          AddButton(WebApplication.Phrase(Setting.Language, 3179), WebApplication.Common.Href(Setting.Name, False, "contact.aspx"), , WebApplication.Components.IconType.Help)
        End If

        'Add "About us"
        If Setting.AboutUs = True AndAlso AboutUsExists() Then
          AddButton(WebApplication.Phrase(Setting.Language, 2006), WebApplication.Common.Href(Setting.Name, False, "default.aspx", "p", 6, "a", 0), , WebApplication.Components.IconType.Document)
        End If

        'Button Chat
        'If User.Role(Setting.Name) > Authentication.User.RoleType.Visitors Then 'Available chat only for new entry user
        If PluginManager.IsEnabled(Setting, "Chat") Then
          AddButton(WebApplication.Phrase(Setting.Language, 2001), WebApplication.Common.Href(Setting.Name, False, "chat.aspx"), , WebApplication.Components.IconType.Chat)
        End If
        'End If

        If Setting.Name <> "" Then
          If User.Role(Setting.Name) >= Authentication.User.RoleType.AdministratorJunior Then
            If Setting.Archive IsNot Nothing Then
              For Each Item As Integer In Setting.Archive
                If Item Then
                  'Button Page Manager
                  AddButton(Common.ButtonsStandard.PageManager)
                  'Button New Page (Add Page)
                  Dim Blink As Boolean = False
                  If Setting.Aspect.SuggestTheBestChoiceByTheBlink Then
                    If Setting.Archive IsNot Nothing AndAlso Setting.Archive.Count = 1 Then
                      If Not HttpContext.Current.Request.Url.LocalPath.EndsWith("/edit.aspx", StringComparison.InvariantCultureIgnoreCase) Then
                        Dim Menu As Menu = Menu.Load(Setting.Archive(0), Setting.Language)
                        If Menu IsNot Nothing AndAlso Menu.ItemsMenu.Count = 0 Then
                          Blink = True
                        End If
                      End If
                    End If
                  End If
                  AddButton(Common.ButtonsStandard.NewPage, Blink)
                  Exit For
                End If
              Next
            End If

            If User.Role(Setting.Name) >= Authentication.User.RoleType.Administrator Then
              'Add Button Tech Support
              Dim TechSupportUrl As String
              If Setting.Language = LanguageManager.Language.Italian Then
                TechSupportUrl = "http://cmsaspnet.com/forum.aspx?ss=forum"
              Else
                TechSupportUrl = "http://ticketopensource.com/forum.aspx"
              End If
              AddButton(Phrase(Setting.Language, 3185), TechSupportUrl, , IconType.TechSupport)

              'Add Button SubSite setting
              AddButton(Phrase(Setting.Language, 3025), WebApplication.Common.Href(Setting.Name, False, "setup.aspx", "config", Setting.Name), Phrase(Setting.Language, 3025, 3026), Components.IconType.ControlPanel)
            End If
            If User.Role(Setting.Name) >= Authentication.User.RoleType.WebMaster Then
              'Add Button WebMaster Panel setting
              AddButton(Phrase(Setting.Language, 144, 145), WebApplication.Common.Href(Setting.Name, False, "configeditor.aspx", "edit", "setup"), Phrase(Setting.Language, 144, 145), Components.IconType.ControlPanel)
            End If
          End If
        End If

        AddCodeFromFile(BarTop)
      End If
    End If

    If BarBottom.Visible Then
      Dim Domain As New WebControls.Label
      Domain.Text = " " & Now.Year & " " & PathCurrentUrl()
      Domain.CssClass = "copyright"
      BarBottom.Controls.Add(Domain)


      '=================================================================
      'Don't remove this routine bellow! This code is part of license! 
      '=================================================================

      Dim LinkCopyright As New HyperLink
      LinkCopyright.NavigateUrl = CopyrightLink
      LinkCopyright.Text = Copyright
      LinkCopyright.CssClass = "cms"
      BarBottom.Controls.Add(LinkCopyright)

      '=================================================================
      ' 
      '=================================================================

      AddCodeFromFile(BarBottom)

      'Add search engine result
      'If Session("OutOfNetworkReferrer") IsNot Nothing Then
      '  Me.BarBottom.Parent.Controls.Add(IFrame("100%", 1200, Session("OutOfNetworkReferrer")))
      'End If

    End If

    If Session("NextMessage") IsNot Nothing Then
      AddMessage(Session("NextMessage"), Setting)
      Session("NextMessage") = Nothing
    End If

    If Messages.Controls.Count Then
      Dim BoxOverlapping As New WebControl(HtmlTextWriterTag.Div)
      ContentPlaceHolder1.Controls.AddAt(0, BoxOverlapping)
      BoxOverlapping.CssClass = "MessageOverlap"
      BoxOverlapping.Controls.Add(Components.TextControl(Message))
      Dim Div As New WebControl(HtmlTextWriterTag.P)
      Div.Controls.Add(Messages)
      ContentPlaceHolder1.Controls.AddAt(0, Div)
    End If

    If Request.Browser.EcmaScriptVersion.Major >= 1 Then
      'Add Messenger Comunication Script
      '(funzione in conflitto con openwysiwyg)>>> Page.Header.Controls.Add(WebApplication.MessengerManager.ScriptCheckEvents(Setting))

      'Detect Time Zone Offset
      If User.ForceDetectTimeOffset Then
        User.DetectTimeOffsetDisabled()
        Page.Header.Controls.Add(ScriptOutside(SourceScript.DetectTimeZoneOffset))
      End If

      'Dim ScriptText As String = ReadAll(MapPath(ScriptsResources & "/" & "closewindow.js"))
      'Dim ScriptNoCloseBrowser As Control = Script(Replace(ScriptText, "GoToUrl", """" & Session("OutOfNetworkReferrer") & """", , , CompareMethod.Text), ScriptLanguage.javascript, "window", "onbeforeunload")
      'Page.Header.Parent.Controls.Add(ScriptNoCloseBrowser)

      If Session("OutOfNetworkReferrer") <> "" Then
        Dim ScriptText As String = HeaderScript
        If StrComp(Request.Browser.Browser, "IE", CompareMethod.Text) = 0 Then
          ScriptText = Replace(ScriptText, ".pageY", ".clientY", , , CompareMethod.Text)
          ScriptText = Replace(ScriptText, ".pageX", ".clientX", , , CompareMethod.Text)
        End If
        Dim BrowserName As String = Request.Browser.Browser
        ScriptText = Replace(ScriptText, "//[not " & BrowserName & "]", "/* [not " & BrowserName & "]", , , CompareMethod.Text)
        ScriptText = Replace(ScriptText, "//END[not " & BrowserName & "]", "[not " & BrowserName & "] */", , , CompareMethod.Text)
        ScriptText = Replace(ScriptText, "//END[not ", "//END [not ", , , CompareMethod.Text)

        ScriptText = Replace(ScriptText, "//[" & BrowserName & "]", "//", , , CompareMethod.Text)
        ScriptText = Replace(ScriptText, "//END[" & BrowserName & "]", "//", , , CompareMethod.Text)

        ScriptText = Replace(ScriptText, "//[", "/*[", , CompareMethod.Text)
        ScriptText = Replace(ScriptText, "//END[", "*/ //[", , , CompareMethod.Text)

        Dim Go As String
        If AutoAdSenseForSearch Then
          Go = Href(Setting.Name, False, "default.aspx", "s", DefaultPageShowType.RedirectToSearchEngine)
        Else
          ScriptText = Replace(ScriptText, "//location", "location", , , CompareMethod.Text)
          ScriptText = Replace(ScriptText, "submitForm.", "//submitForm.", , , CompareMethod.Text)
          Go = Session("OutOfNetworkReferrer")
        End If
        ScriptText = Replace(ScriptText, "OutOfNetworkReferrer", """" & AbjustForJavascriptString(Go) & """", , , CompareMethod.Text)

        ScriptText = Replace(ScriptText, "ExitMessage", """" & AbjustForJavascriptString(Phrase(Setting.Language, 136) & " " & CurrentDomain()) & """", , , CompareMethod.Text)
        Dim ScriptNoCloseBrowser As Control = Script(ScriptText, ScriptLanguage.javascript)
        BottomPlaceHolder.Controls.Add(ScriptNoCloseBrowser)
      End If
    End If

    If Rating Then
      'Add tool rating user
      Dim RatingControl As New WebControl(HtmlTextWriterTag.Div)
      RatingControl.Attributes.Add("itemscope", "itemscope")
      RatingControl.Attributes.Add("itemtype", "http://schema.org/Rating")
      Dim RatingValue As New WebControl(HtmlTextWriterTag.Meta)
      RatingValue.Attributes.Add("itemprop", "ratingValue")
      RatingValue.Attributes.Add("content", Rating)
      RatingControl.Controls.Add(RatingValue)
      Dim BestRating As New WebControl(HtmlTextWriterTag.Meta)
      BestRating.Attributes.Add("itemprop", "bestRating")
      BestRating.Attributes.Add("content", 5)
      RatingControl.Controls.Add(BestRating)
      ContentPlaceHolder1.Controls.Add(RatingControl)
    End If

    'If IsCrawler(Request) Then
    'If Rating Then
    '	Dim Box As New WebControl(HtmlTextWriterTag.Div)
    '	Box.CssClass = "hreview"
    '	Box.Attributes.Add("itemprop", "rating")
    '	Box.Attributes.Add("itemscope", "itemscope")
    '	Box.Attributes.Add("itemtype", "http://data-vocabulary.org/Rating")

    '	Dim Fn As New WebControl(HtmlTextWriterTag.Span)
    '	Fn.CssClass = "fn"
    '	Fn.Controls.Add(TextControl(Page.Title))
    '	Box.Controls.Add(Fn)

    '	Dim Reviewer As New WebControl(HtmlTextWriterTag.Span)
    '	Reviewer.CssClass = "reviewer"
    '	Reviewer.Controls.Add(TextControl(PathCurrentUrl))
    '	Box.Controls.Add(Reviewer)

    '	Dim Rating As New WebControl(HtmlTextWriterTag.Span)
    '	Rating.CssClass = "rating"
    '	Rating.Controls.Add(TextControl(Me.Rating))
    '	Box.Controls.Add(Rating)

    '	ContentPlaceHolder1.Controls.Add(Box)
    'End If

    'If Authors.Count = 1 Then
    'Dim Author As User = Authors(0)
    For Each Author As User In Authors

      Select Case 1
        Case 1
          Dim Link As New WebControl(HtmlTextWriterTag.Link)
          Link.Attributes.Add("rel", "author")
          Link.Attributes.Add("href", Author.Href(Setting))
          ContentPlaceHolder1.Controls.AddAt(0, Link)
        Case 2
          Dim Vcard As New WebControl(HtmlTextWriterTag.Span)
          Vcard.CssClass = "vcard"

          Dim PageAuthor As String = Author.URL
          If PageAuthor IsNot Nothing AndAlso PageAuthor.Contains("://plus.google.com/") Then
            If Not PageAuthor.Contains("?rel=author") Then
              PageAuthor &= "?rel=author" 'https://spreadsheets.google.com/spreadsheet/viewform?formkey=dHdCLVRwcTlvOWFKQXhNbEgtbE10QVE6MQ&ndplr=1
            End If
          End If

          Dim AuthorA As New WebControl(HtmlTextWriterTag.A)
          AuthorA.CssClass = "url fn"
          AuthorA.Attributes.Add("rel", "author")
          AuthorA.Attributes.Add("href", PageAuthor)
          AuthorA.Controls.Add(TextControl(Author.FirstName & " " & Author.LastName & "+")) 'https://spreadsheets.google.com/spreadsheet/viewform?formkey=dHdCLVRwcTlvOWFKQXhNbEgtbE10QVE6MQ&ndplr=1
          Vcard.Controls.Add(AuthorA)
          ContentPlaceHolder1.Controls.AddAt(0, Vcard)
      End Select

    Next
    'End If

    'End If

  End Sub

  Shared HeaderScript As String = ReadAll(Extension.MapPath(ScriptsResources & "/" & "HeaderScript.js")) 'Cache this script

  Shared AboutUs As New System.Collections.Generic.Dictionary(Of LanguageManager.Language, Boolean)
  Private Function AboutUsExists() As Boolean
    If AboutUs.ContainsKey(Setting.Language) Then
      Return AboutUs.ContainsKey(Setting.Language)
    Else
      If System.IO.File.Exists(MenuManager.PageNameFile(1, 6, Setting.Language)) Then
        Try
          AboutUs.Add(Setting.Language, True)
        Catch ex As Exception
        End Try
        Return True
      Else
        Try
          AboutUs.Add(Setting.Language, False)
        Catch ex As Exception
        End Try
        Return False
      End If
    End If
  End Function

  Private Function AdSenseReferralCode(ByVal Width As Integer, ByVal Height As Integer, ByVal CpaChoice As String) As String
    Dim ReferralAdSenseCode As String = WebApplication.ReadAll(WebApplication.Extension.MapPath(WebApplication.CodesSubDirectory & "\adsense_referral.html"))
    ReferralAdSenseCode = Replace(ReferralAdSenseCode, "#CLIENT", Setup.Affiliations.Google_Client)
    ReferralAdSenseCode = Replace(ReferralAdSenseCode, "#WIDTH", CStr(Width))
    ReferralAdSenseCode = Replace(ReferralAdSenseCode, "#HEIGHT", CStr(Height))
    ReferralAdSenseCode = Replace(ReferralAdSenseCode, "#CPACHOICE", CpaChoice)
    Return ReferralAdSenseCode
  End Function

  Private Sub AddTopMiniBanner(ByVal ImageUrl As String, ByVal ToolTip As String, ByVal Href As String)
    Dim HyperLink As New WebControls.HyperLink
    HyperLink.ToolTip = EncodingAttribute(ToolTip)
    HyperLink.NavigateUrl = Href
    Dim Image As New WebControls.Image
    Image.AlternateText = ToolTip
    Image.ImageUrl = ImageUrl
    Dim Width, Height As Integer
    CacheImageSize.LoadWidthHeight(Image.ImageUrl, Width, Height)
    Image.Width = Width
    Image.Height = Height
    HyperLink.Controls.Add(Image)
    TopRight.Controls.Add(HyperLink)
  End Sub

  Private Sub AddCodeCounter()
    Dim Control As New Web.UI.WebControls.Literal
    Control.ID = "CodeCounter"
    Dim Html As String = _
    "<span id=""CodeCounter"">" & _
    WebApplication.Config.CodeCounter & _
    "</span>"
    If Setup.RenderingEngine.HideStatsCode Then
      Html &= _
       "<script type=""text/javascript"">" & _
       "CodeCounter.outerHTML="""";" & _
       "</script>"
    End If
    Control.Text = Html
    BarBottom.Controls.Add(Control)
    'Me.Controls.Add(Control)
  End Sub

  Private Sub AddLinksDomains(ByVal Hide As Boolean)
    'Add link friend host to best ranking
    Dim Ctrl As New WebControl(HtmlTextWriterTag.Span)
    Dim AllDomainNames = WebApplication.AllDomainNames
    If AllDomainNames IsNot Nothing Then
      For Each Domain As String In WebApplication.AllDomainNames
        Dim Link As New HyperLink
        Dim P1 As Integer = InStr(Domain, ".", CompareMethod.Binary)
        Dim P2 As Integer = InStr(P1 + 1, Domain, ".", CompareMethod.Binary)
        If P1 <> 0 And P2 = 0 Then
          Link.NavigateUrl = "http://www." & Domain
        Else
          Link.NavigateUrl = "http://" & Domain
        End If
        Dim DomainConfiguration As DomainConfiguration
        DomainConfiguration = DomainConfiguration.Load(Domain)
        If DomainConfiguration.SubSitesAvailable.Count Then
          Dim SubSite As WebApplication.SubSite
          SubSite = SubSite.Load(DomainConfiguration.SubSitesAvailable(0))

          If SubSite.Title <> "" Then
            Link.Text = HttpUtility.HtmlEncode(SubSite.Title)
          Else
            Link.Text = HttpUtility.HtmlEncode(Link.NavigateUrl)
          End If
          Ctrl.Controls.Add(WebApplication.Flag(SubSite.Language))
          Ctrl.Controls.Add(Link)
          Ctrl.Controls.Add(New LiteralControl("   "))
        End If
      Next
      BarBottom.Controls.Add(Ctrl)
      If Hide Then
        BarBottom.Controls.Add(Script(Ctrl.ClientID & ".style.display='none';", ScriptLanguage.javascript))
      End If
    End If
  End Sub

  Private Function ToolsBarAddButton(ByVal Where As Control, ByVal Text As String, ByVal Href As String, Optional ByVal ToolTip As String = Nothing, Optional ByVal Icon As IconType = Nothing, Optional ByVal Target As TargetForButton = TargetForButton.Self, Optional ByVal Nofollow As Boolean = False, Optional ByVal OnClick As String = Nothing, Optional Blink As Boolean = False) As WebControl
    Dim Button As WebControl
    Dim TargetName As String = Nothing
    Select Case Target
      Case TargetForButton.Messenger
        TargetName = Window.Messenger.ToString
      Case TargetForButton.Blank
        TargetName = "_blank"
    End Select
    Button = WebApplication.Components.Button(Setting, Text, Href, ToolTip, Icon, TargetName, Nofollow)
    If OnClick IsNot Nothing AndAlso OnClick <> "" Then
      Button.Attributes.Add("onclick", OnClick)
    End If
    If Blink Then
      Me.Blink(Button)
    End If
    ToolsBar.Controls.Add(Button)
    Return Button
  End Function

  Overrides Sub Blink(Control As Control)
    AddBlinkCode()
    'Control.Style.Add("text-decoration", "blink!important")	
    If TypeOf Control Is WebControl Then
      Dim Ctrl As WebControl = Control
      If Ctrl.CssClass <> "" Then
        Ctrl.CssClass &= " blink"
      Else
        Ctrl.CssClass = "blink"
      End If
    ElseIf TypeOf Control Is HtmlControl Then
      Dim Ctrl As HtmlControl = Control
      If Ctrl.Attributes("class") <> "" Then
        Ctrl.Attributes("class") &= " blink"
      Else
        Ctrl.Attributes("class") = "blink"
      End If
    End If
  End Sub

  Private Sub AddBlinkCode()
    Static AddedBlinkCode As Boolean
    If Not AddedBlinkCode Then
      AddedBlinkCode = True
      Page.Header.Controls.Add(Script(Replace(Replace("function blink(){var bt = document.getElementsByClassName('blink');for (i=0; i<bt.length; i++){try{bt[i].style.color=bt[i].currentStyle.color;bt[i].style.backgroundColor=bt[i].currentStyle.backgroundColor}catch(err){bt[i].style.color=window.getComputedStyle(bt[i], null).color;bt[i].style.backgroundColor=window.getComputedStyle(bt[i], null).backgroundColor}t=bt[i].style.color;bt[i].style.color=bt[i].style.backgroundColor;bt[i].style.backgroundColor=t}setTimeout('blink()',500)};setTimeout('blink()',500)", ";", vbCrLf & ";"), "{", vbCrLf & "{"), ScriptLanguage.javascript))
    End If
  End Sub

  Protected Sub MasterPage_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init
    Setting = CurrentSetting()

    'Block not autorized plugin for current user
    Dim CurrentPageName As String = Mid(Page.ToString, 5)
    CurrentPageName = CurrentPageName.Substring(0, Len(CurrentPageName) - 5) & ".aspx"
    For Each Plugin As PluginManager.Plugin In AllPlugins()
      If Plugin.AspxFileName = CurrentPageName Then
        If Not Plugin.IsEnabledAndAccessible(User, Setting) Then
          Response.End()
        End If
      End If
    Next
    RaiseMasterPageInitEvent(Me, User, Setting)
    If Setup.SEO.EntrapUsersFromSearchEngines Then
      Dim QuerryReferrer As Boolean
      Try
        If Request IsNot Nothing AndAlso Request.UrlReferrer IsNot Nothing AndAlso Request.UrlReferrer.Query <> "" AndAlso Request.Url.Host <> Request.UrlReferrer.Host Then
          QuerryReferrer = True
        End If
      Catch ex As Exception
      End Try
      If QuerryReferrer Then
        If Request.Form("payment_status") <> "" Then
          'Is a paypal IPN notification
          Exit Sub
        End If

        'Is request is from external network domine
        Dim FromHost As String = Request.UrlReferrer.Host.ToLower
        If FromHost.StartsWith("www.") Then
          FromHost = Mid(FromHost, 5)
        End If
        If Not AllDomainNames().Contains(FromHost) Then
          Dim Ref As New System.Web.HttpRequest("", Request.UrlReferrer.AbsoluteUri, Web.HttpUtility.UrlDecode(Request.UrlReferrer.Query.Substring(1)))
          Dim QueryName As String
          If InStr(Request.UrlReferrer.AbsoluteUri, "yahoo.") <> 0 Then
            QueryName = "P"
          Else
            QueryName = "q"
          End If
          Dim Query As String = Ref.QueryString(QueryName)

          If Query <> "" Then
            Dim FromInsideSiteSearch As Boolean = Session("OutOfNetworkReferrer") <> ""
            Dim NewOutOfNetworkReferrer As String = HttpContext.Current.Request.UrlReferrer.AbsoluteUri
            If NewOutOfNetworkReferrer.ToLower.EndsWith("/default.aspx") Then
              NewOutOfNetworkReferrer = NewOutOfNetworkReferrer.Substring(0, NewOutOfNetworkReferrer.Length - 12)
            End If
            If Not FromInsideSiteSearch Then
              Dim IsFromGoogle As Boolean = InStr(Request.UrlReferrer.Host, "google", CompareMethod.Text) <> 0
              Dim MyHost As String = CurrentDomain()
              If IsFromGoogle Then
                If Request.UrlReferrer.LocalPath.EndsWith("/url") Then
                  'is a google counter!  Replace the counter with a google search page
                  NewOutOfNetworkReferrer = Request.UrlReferrer.Scheme & System.Uri.SchemeDelimiter & Request.UrlReferrer.Host & "/search?q=" & HttpUtility.UrlEncode(Query)
                End If
                NewOutOfNetworkReferrer &= "&sitesearch=" & MyHost
                If Setup.Affiliations.Google_Client <> "" Then
                  NewOutOfNetworkReferrer &= "&client=" & Setup.Affiliations.Google_Client
                End If
              Else
                NewOutOfNetworkReferrer = Replace(NewOutOfNetworkReferrer, "?" & QueryName & "=", "?" & QueryName & "=site%3A" & MyHost & "+", , , CompareMethod.Text)
                NewOutOfNetworkReferrer = Replace(NewOutOfNetworkReferrer, "&" & QueryName & "=", "&" & QueryName & "=site%3A" & MyHost & "+", , , CompareMethod.Text)
              End If
              'End If

              'Add search result in the footer if reference is from search engine
              'Session("SearchEngineReference") = NewOutOfNetworkReferrer

              'If back to search engine show only results for this domain!
              'Dim OutOfNetworkReferrer As String = Session("OutOfNetworkReferrer")
              'If Not FromInsideSiteSearch Then
              If Request.Browser.EcmaScriptVersion.Major Then
                If InStr(Request.UserAgent, "Google", CompareMethod.Text) = 0 Then
                  'If Request.UrlReferrer.Query <> "" Then
                  Dim MyUrl As String = HttpContext.Current.Request.Url.LocalPath
                  If MyUrl.EndsWith("/default.aspx", StringComparison.InvariantCultureIgnoreCase) Then
                    MyUrl = MyUrl.Substring(0, MyUrl.Length - 13)
                  End If
                  Dim BackToUrl As String
                  If HttpContext.Current.Request.Url.Query.StartsWith("?404;") Then
                    BackToUrl = Replace(HttpContext.Current.Request.Url.Query.Substring(5), ":80/", "/", , , CompareMethod.Binary)
                  Else
                    BackToUrl = HttpContext.Current.Request.Url.Scheme & System.Uri.SchemeDelimiter & HttpContext.Current.Request.Url.Authority & MyUrl & HttpContext.Current.Request.Url.Query
                  End If
                  Session("BackToUrl") = BackToUrl
                  Session("QuerySearch") = Query
                  Session("OutOfNetworkReferrer") = NewOutOfNetworkReferrer
                  Dim Redirect As String = Href(Me.Setting.Name, True, "default.aspx", "s", DefaultPageShowType.RedirectToSearchEngine)
                  Response.Redirect(Redirect)
                  Exit Sub
                  'End If
                End If
              End If
            End If
          End If
        End If
      End If
    End If

    'Redirect uppercase url
    Dim uri As String = HttpContext.Current.Request.Url.AbsoluteUri
    'If uri <> uri.ToLower Then
    'Redirect301(uri.ToLower)
    'End If

    'Block user not autorized
    If Setup.Security.BlockIPAddresses <> Configuration.BlockIPMode.Disabled Then
      WebApplication.BlockIPAddress()
    End If
    WebApplication.BlockExcludedUser()

    'Set localization
    WebApplication.LanguageManager.SetLocalization(Page, Setting.Language)
  End Sub


  Protected Sub MasterPage_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
    If Setting.IsTrue("SpinningMessage3d") Then
      AddSpinningMessage3d(Page)
    End If
    SetElements(Setting)
    SetMetaTags()

    If Request.Browser.Browser = "IE" AndAlso Request.Browser.MajorVersion < 9 Then
      'Preserve html5 compatibility with IE8: http://code.google.com/p/html5shiv/
      Page.Header.Controls.Add(Script(ScriptLanguage.javascript, "//html5shiv.googlecode.com/svn/trunk/html5.js"))
    End If
    Page.Header.Controls.Add(Script("if(screen.width<=800){document.getElementById('ctl00_StyleSheetHandheld').media='screen'}", ScriptLanguage.javascript))

    If Request.Browser.IsMobileDevice Then
      Dim X As Integer = Request.Browser.ScreenPixelsWidth
      Dim TextStyle As New LiteralControl(".Container{width:" & X & "px;}")
      Dim Style As New WebControl(HtmlTextWriterTag.Style)
      Style.Controls.Add(TextStyle)
      Page.Header.Controls.Add(Style)
    End If

    If Request.Browser.VBScript = True Then
      If Setting.IsTrue("MicrosoftAgent") Then
        BarBottom.Controls.Add(TextToSpeekClientCode(Setting.Language, Setting.Int("MicrosoftAgentCharacter")))
      End If
    End If

    If Request.Browser.EcmaScriptVersion.Major >= 1 Then
      'Add script to Break out of ANY iFrame 
      Me.Page.Header.Controls.Add(Script("if(top!=self){top.location.href=self.location.href}", ScriptLanguage.javascript))

      Dim Path As String
      If Setting.IsTrue("Enabled", "Search") Then
        Path = Href(CurrentDomainConfiguration, Setting.Name, True, "search.aspx", "q=")
      Else
        Dim Domain As String = DomainConfiguration.DomainForSearchFunction(Setting.Language)
        If Domain IsNot Nothing Then
          Path = Href(DomainConfiguration.Load(Domain), Nothing, True, Nothing, "q=")
        End If
      End If
      If Path IsNot Nothing Then
        If CodeClickToSearch Is Nothing Then
          CodeClickToSearch = ReadAll(MapPath(ScriptsResources & "/" & "Search.js"))
        End If
        Dim CodeSearch As String = CodeClickToSearch.Replace("DomainName", Path)
        Me.Page.Header.Controls.Add(Components.Script(CodeSearch, ScriptLanguage.javascript))
        Me.Page.Form.Attributes.Add("ondblclick", "WebSearch()")
      End If

      If False Then 'DISABLE/ENABLE
        'Add script redirect page to seach engine wen exit from network
        Dim FromSite As String = Session("referer")
        If FromSite = "" AndAlso Request IsNot Nothing AndAlso Request.UrlReferrer IsNot Nothing Then
          Dim Domain As String = CurrentDomain()
          For Each DomainInNetwork As String In AllDomainNames()
            If Domain <> DomainInNetwork Then
              Dim Ref As New System.Web.HttpRequest("", Request.UrlReferrer.AbsoluteUri, Web.HttpUtility.UrlDecode(Request.UrlReferrer.Query.Substring(1)))
              If Ref.QueryString("q") <> "" Then
                FromSite = HttpContext.Current.Request.UrlReferrer.AbsoluteUri
                Session("referer") = FromSite
              End If
              Exit For
            End If
          Next
        End If
        If FromSite <> "" Then
          If InStr(FromSite, "sitesearch", CompareMethod.Text) = 0 Then
            FromSite &= "&sitesearch=" & Request.Url.Host
            Dim CodeUnloadPage As String
            CodeUnloadPage = "window.open('http://www.google.com/','_blank');"
            BottomPlaceHolder.Controls.Add(Components.Script(CodeUnloadPage, ScriptLanguage.javascript, "document", "onbeforeunload"))
          End If
        End If
      End If


    End If
    If _OverlappingContent Then
      AddHeader(ReadAll(MapPath(ScriptsResources & "/" & "OverlappingContentLink.js")))
    End If

    If UseGoogleOff Then
      If BarLeft.Visible Then
        BarLeft.Parent.Controls.AddAt(BarLeft.Parent.Controls.IndexOf(BarLeft), New LiteralControl(GoogleOffTag))
        BarLeft.Parent.Controls.AddAt(BarLeft.Parent.Controls.IndexOf(BarLeft) + 1, New LiteralControl(GoogleOnTag))
        'GoogleOffBarLeft.Controls.Add(New LiteralControl(GoogleOffTag))
        'GoogleOnBarLeft.Controls.Add(New LiteralControl(GoogleOnTag))
      End If
      If BarRight.Visible Then
        BarRight.Parent.Controls.AddAt(BarRight.Parent.Controls.IndexOf(BarRight), New LiteralControl(GoogleOffTag))
        BarRight.Parent.Controls.AddAt(BarRight.Parent.Controls.IndexOf(BarRight) + 1, New LiteralControl(GoogleOnTag))
        'GoogleOffBarRight.Controls.Add(New LiteralControl(GoogleOffTag))
        'GoogleOnBarRight.Controls.Add(New LiteralControl(GoogleOnTag))
      End If
      If BarTop.Visible Then
        BarTop.Parent.Controls.AddAt(BarTop.Parent.Controls.IndexOf(BarTop), New LiteralControl(GoogleOffTag))
        BarTop.Parent.Controls.AddAt(BarTop.Parent.Controls.IndexOf(BarTop) + 1, New LiteralControl(GoogleOnTag))
        'GoogleOffBarTop.Controls.Add(New LiteralControl(GoogleOffTag))
        'GoogleOnBarTop.Controls.Add(New LiteralControl(GoogleOnTag))
      End If
      If BarBottom.Visible Then
        BarBottom.Parent.Controls.AddAt(BarBottom.Parent.Controls.IndexOf(BarBottom), New LiteralControl(GoogleOffTag))
        BarBottom.Parent.Controls.AddAt(BarBottom.Parent.Controls.IndexOf(BarBottom) + 1, New LiteralControl(GoogleOnTag))
        'GoogleOffFooter.Controls.Add(New LiteralControl(GoogleOffTag))
        'GoogleOnFooter.Controls.Add(New LiteralControl(GoogleOnTag))
      End If
    End If

    RaiseMasterPagePreRenderEvent(Me, User, Setting)

    If form1.Action = "" Then
      'This resolve html5 validation of action attribute
      form1.Action = Request.CurrentExecutionFilePath & Request.Url.Query
    End If

    If BarRight.Controls.Count = 0 Then
      BarRight.Visible = False
    End If

    For Each BottomContent As BottomContent In CollectionOfBottomContent
      If BottomContent.Bar.Controls.Count = 0 Then
        BottomContent.Bar.Visible = False
      End If
    Next

  End Sub

  Private Sub SetMetaTags()

    Dim Charset As String
    If Response.Charset = "utf-8" Then
      Charset = "UTF-8"
    Else
      Charset = Response.Charset
    End If

    'Html5
    Me.Page.Header.Controls.AddAt(1, New LiteralControl("<meta charset=""" & Charset & """>"))

    'Xhtml (Not supported in html5)
    'AddMetaTag("Content-Type", Response.ContentType & ";charset=" & Charset)

    StyleSheet.Href = Href(Setting.Name, False, "css.aspx", "skin", Setting.Skin.Id)
    StyleSheetHandheld.Href = Href(Setting.Name, False, "css.aspx", "skin", Setting.Skin.Id, "media", "handheld")
    StyleSheetPrint.Href = Href(Setting.Name, False, "css.aspx", "skin", Setting.Skin.Id, "media", "print")

    'StyleSheetHandheld.Attributes.Add("onload", "if(screen.width<=800){document." & StyleSheetHandheld.ID & ".media='screen'}")
    If Request.UserAgent <> "" AndAlso LCase(Request.UserAgent).Contains("webkit") Then
      'Istance on fly this next tag link:
      '<link id="StyleSheetAndroid" rel="stylesheet" href="css.aspx" type="text/css" media="screen and (-webkit-device-pixel-ratio:0.75)"	runat="server" />
      Dim StyleSheetAndroid As New WebControl(HtmlTextWriterTag.Link)
      StyleSheetAndroid.Attributes.Add("rel", "stylesheet")
      StyleSheetAndroid.Attributes.Add("href", Href(Setting.Name, False, "css.aspx", "skin", Setting.Skin.Id, "media", "handheld"))
      StyleSheetAndroid.Attributes.Add("type", "text/css")
      StyleSheetAndroid.Attributes.Add("media", "screen and (-webkit-device-pixel-ratio:0.75)")
      Page.Header.Controls.Add(StyleSheetAndroid)
    End If

    If m_Description <> "" Then
      AddMetaTag("description", m_Description)
      'If AuthorOff = False Then
      '	AddMetaTag("author", m_Description)
      'End If
    End If
    If m_KeyWords <> "" Then AddMetaTag("keywords", m_KeyWords)
    If RobotsOff = False Then
      AddMetaTag("robots", "index,follow")
      AddMetaTag("revisit-after", m_MetaRevisitAfterDays & " Days")
    End If
    If NoArchive = False AndAlso Setup.SEO.PreventCrawlerArchivingOfContent = True Then
      AddMetaTag("robots", "noarchive")
    End If

    html.Attributes.Add("lang", m_Language)
    'AddMetaTag(Nothing, m_Language, "content-language")
    'AddMetaTag("Language", m_Language)
    'AddMetaTag("Expires", Now.AddMinutes(2).ToString("r"))
    If User.Username = "" Then
      Response.Cache.SetExpires(Now.AddMinutes(2))
    End If

  End Sub

  Public Overrides Function MetaTag(ByVal Name As String) As HtmlMeta
    For Each Ctrl As Object In Me.Page.Header.Controls
      If TypeOf Ctrl Is HtmlMeta Then
        If Ctrl.Name = Name Then
          Return Ctrl
        End If
      End If
    Next
  End Function

  Public Overrides Sub AddMetaTag(ByVal Name As String, ByVal Content As String, Optional ByVal HttpEquiv As String = Nothing)
    Select Case LCase(Name)
      Case "author"
        AuthorOff = True
      Case "robots"
        If Content = "noarchive" Then
          NoArchive = True
        Else
          RobotsOff = True
        End If
    End Select
    Dim MetaTag As New HtmlMeta()
    If Not Name Is Nothing Then
      MetaTag.Name = Name
    End If
    MetaTag.Content = Content
    If Not HttpEquiv Is Nothing Then
      MetaTag.HttpEquiv = HttpEquiv
    End If
    Me.Page.Header.Controls.Add(MetaTag)
  End Sub

  Public Overrides Sub SetTrace(ByVal ParamArray Controls() As Control)
    TraceControls = Controls
  End Sub
  Private Messages As New PlaceHolder
  Private Message As String
  Public Overrides Sub AddMessage(ByVal Text As String, Setting As SubSite, Optional ByVal ToolTip As String = Nothing, Optional ByVal Href As String = Nothing, Optional ByVal Type As MessageType = MessageType.Normal)
    If Messages.Controls.Count Then
      Messages.Controls.Add(BR)
    End If
    Messages.Controls.Add(Components.Message(Text, Setting, ToolTip, Href, Type))
    If Message <> "" Then
      Message &= vbCrLf
    End If
    Message &= Text
  End Sub

  Public Overrides Sub AddMessage(Setting As SubSite, ByVal IDText As Integer, Optional ByVal IDToolTip As Integer = Nothing, Optional ByVal Href As String = Nothing, Optional ByVal Type As MessageType = MessageType.Normal)
    Dim Text As String = Phrase(Setting.Language, IDText)
    AddMessage(Text, Setting, Phrase(Setting.Language, IDToolTip), Href, Type)
  End Sub

  Public Overrides Sub AddMessage(Control As Control)
    If Messages.Controls.Count Then
      Messages.Controls.Add(BR)
    End If
    Messages.Controls.Add(Control)
  End Sub

  Private _OverlappingContent As Boolean
  Public Overrides Property OverlappingContent() As Boolean
    Get
      Return _OverlappingContent
    End Get
    Set(ByVal value As Boolean)
      _OverlappingContent = value
    End Set
  End Property


  Public Sub AddCodeFromFile(ByVal Control As Control, Optional ByVal FileName As String = Nothing)
    If FileName Is Nothing Then
      FileName = Control.ID
    End If
    Dim Domain = CurrentDomain()
    For BySetting As Integer = 0 To 2
      For ByLanguage As Integer = 0 To 1
        Dim Lng, NameSetting As String
        Select Case BySetting
          Case 0
            NameSetting = ""
          Case 1
            NameSetting = "." & Setting.Name
          Case 2
            NameSetting = "." & Domain
        End Select
        Select Case ByLanguage
          Case 0
            Lng = ""
          Case Else
            Lng = "." & WebApplication.LanguageManager.Acronym(Setting.Language)
        End Select
        Dim NameFile As String = FileName & NameSetting & Lng & ".html"
        Dim Code As String = HtmlCodesToAddingInPage(NameFile)
        If Code <> "" Then
          Dim CodeObj As New WebControls.Literal
          CodeObj.Text = Code
          Control.Controls.Add(CodeObj)
        End If
      Next
    Next
  End Sub

  Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    If Common.WebCache Is Nothing Then
      'Here Only once time operations!
      Common.WebCache = HttpContext.Current.Cache
      SyncLock Common.WebCache
        Dim NewThread As System.Threading.Thread = New System.Threading.Thread(AddressOf UpdateCodeFile)
        NewThread.Priority = Threading.ThreadPriority.Lowest
        NewThread.IsBackground = True
        NewThread.Start()
      End SyncLock
    End If

    If UseAlternativeLoadPluginMethod = NeedAlternativeMethodLoad.Need Then
      UseAlternativeLoadPluginMethod = NeedAlternativeMethodLoad.Run
      LoadPluginsByAspxFileWebRequest(PathCurrentUrl)
      Dim NewThread As System.Threading.Thread = New System.Threading.Thread(AddressOf LoadPluginsByAspxFileWebRequest)
      NewThread.Priority = Threading.ThreadPriority.Lowest
      NewThread.IsBackground = True
      NewThread.Start()
    End If
  End Sub
End Class




