Imports WebApplication
Partial Class EditPage
  Inherits System.Web.UI.Page
	Private Setting As Config.SubSite
	Private Archive As Integer = -1
	Private NPage As Integer
	Private Language As LanguageManager.Language
	Private MasterPage As MasterPage

	Protected Sub EditPage_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init
		Setting = CurrentSetting()
		RegisterAnonimus()
		If Request.QueryString("archive") <> "" Then
			Archive = Val(Request.QueryString("archive"))
		Else
			If Setting.Archive IsNot Nothing Then
				If Setting.Archive.Length = 1 Then
					Archive = Setting.Archive(0)
				End If
			End If
		End If
		NPage = Val(Request.QueryString("page"))
		If NPage = 0 And IsNumeric(Request.Form(NewNPage.UniqueID)) Then
			NPage = Request.Form(NewNPage.UniqueID)
		End If
		Language = Val(Request.QueryString("lng"))
		If Language = Language.NotDefinite Then
			Language = Setting.Language
		End If
		Dim Block As Boolean
		If CurrentUser.Role(Setting.Name) < Authentication.User.RoleType.AdministratorJunior Then
			Block = True
		Else
			If CurrentUser.Role(Setting.Name) < Authentication.User.RoleType.WebMaster And NPage <> 0 Then
				Block = True
				If Setting.Archive IsNot Nothing Then
					For Each Id As Integer In Setting.Archive
						If Id = Archive Then
							Block = False
						End If
					Next
				End If
			End If
		End If
		If Block Then
			Response.Clear()
			Response.End()
		End If
	End Sub

	Protected Sub edit_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		MasterPage = SetMasterPage(Me, , False, False)
	End Sub

	Private Function PageNameFile(ByVal Archive As Integer, ByRef NPage As Integer, ByVal Language As LanguageManager.Language) As String
		If NPage Then
			Return MenuManager.PageNameFile(Archive, NPage, Language)
		Else
			Do
				NPage += 1
			Loop Until Not IO.File.Exists(MenuManager.PageNameFile(Archive, NPage, Language))
			Return MenuManager.PageNameFile(Archive, NPage, Language)
		End If
	End Function

	'Private Function AddIcon(ByVal Text As String, Optional ByVal Font As String = "Webdings") As String
	'	Dim Ctrl As New WebControls.Label
	'	Ctrl.Font.Name = Font
	'	Ctrl.Text = Text
	'	Return ControlToText(Ctrl)
	'End Function

	Private Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.PreRender
		SetVisualization()
	End Sub
	Private Sub SetVisualization()

		Dim Source As String = ReadAll(MapPath(Config.Resources & "\TinyMCE\config.html"))
		'Source = Replace(Source, "'html'", "'" & Html.ClientID & "'", , , CompareMethod.Text)
		Dim Script As New Literal
		Script.Text = Source
		Script1.Controls.Add(Script)

		For Each Value As EnabledStatus In [Enum].GetValues(GetType(EnabledStatus))
			Dim ListItem As New WebControls.ListItem
			Dim Word As Integer
			Select Case Value
				Case EnabledStatus.Default
					Word = 3167
				Case EnabledStatus.Yes
					Word = 126
				Case Else
					Word = 127
			End Select
			ListItem.Text = Phrase(Setting.Language, Word)
			ListItem.Value = Value
			ShowDate.Items.Add(ListItem)
		Next

		If Archive = -1 Then
			Panel1.Visible = False
			If Setting.Archive IsNot Nothing Then

				Dim Box As New WebControl(HtmlTextWriterTag.Div)
				Box.CssClass = "Menu"

				For Each Archive As Integer In Setting.Archive
					Dim Text As String = ""
					Dim Menu As Menu = Menu.Load(Archive, Setting.Language)
					For Each ItemMenu As ItemMenu In Menu.ItemsMenu
						If ItemMenu.Level = 0 Then
							Text &= "\" & ItemMenu.Description.Label
						End If
					Next
					If Text = "" Then
						Text = Phrase(Setting.Language, 3015) & " " & Archive
					End If
					Dim Link As String = Href(Setting.Name, False, "edit.aspx", "archive", Archive, "lng", Setting.Language)

					Box.Controls.Add(Components.Folder(Text, Phrase(Setting.Language, 52), Link, Setting))

				Next
        Dim Content As Control = MasterPage.ContentPlaceHolder
				Content.Controls.Add(Box)
			End If
		Else
			Dim CurrentAlbum As String
			Dim CurrentPhoto As String
			Dim FileName As String = MenuManager.PageNameFile(Archive, NPage, Language)
			If IO.File.Exists(FileName) Then
				'Dim Code As String = Extension.ReadAll(FileName)
				'Dim MetaTags As New MetaTags(Code)
				Dim Document As New HtmlDocument(FileName)
				Select Case Page.IsPostBack
					Case False
						If NPage Then
							TitlePage.Text = Document.MetaTags.Title
							Description.Text = Document.MetaTags.Description
							KeyWords.Text = Document.MetaTags.KeyWords
							CorrelatedWords.Text = Document.MetaTags.Collection("CorrelatedKeyWords")
							Dim Status As SubSite.CerrelatedStructure.CorrelatedStatus
							Status = Document.MetaTags.Collection("CorrelatedStatus")
							Select Case Status
								Case Config.SubSite.CerrelatedStructure.CorrelatedStatus.Enabled
									CW_Enabled.Checked = True
								Case Config.SubSite.CerrelatedStructure.CorrelatedStatus.Context
									CW_SameDomain.Checked = True
								Case Config.SubSite.CerrelatedStructure.CorrelatedStatus.NotEnabled
									CW_NotEnabled.Checked = True
							End Select
							If Document.MetaTags.MetaTag("EnabledComments") <> "" Then
								EnabledComments.Checked = CBool(Document.MetaTags.MetaTag("EnabledComments"))
							End If
							Dim ShowDateValue As EnabledStatus
							If Document.MetaTags.MetaTag("ShowDate") <> "" Then
								ShowDateValue = Document.MetaTags.MetaTag("ShowDate")
							End If

							For Each Item As ListItem In ShowDate.Items
								If Item.Value = ShowDateValue Then
									Item.Selected = True
									Exit For
								End If
							Next

              CurrentAlbum = Document.MetaTags.MetaTag("PhotoAlbum")
              If CurrentAlbum <> "" Then
                AddPhotoAlbum.Checked = True
              Else
                CurrentPhoto = Document.MetaTags.MetaTag("Photo")
                If CurrentPhoto <> "" Then
                  CurrentAlbum = Split(CurrentPhoto, ".")(0)
                End If
              End If
              VideoID.Text = Document.MetaTags.Collection("Video")
              Html.Value = Document.Body
            End If
        End Select
        If DeletePermission(Document.MetaTags.Author) Then
          Delete.Visible = True
        End If
      Else
        Delete.Visible = False
      End If
      'MenuEditor.Controls.Add(StandardButton)

      'add select photo and album
      'Add code preview photo

      AddScriptClientPreviewPhoto(PhotoList, imgpreview)
      'Dim SrcBase As String = Href(Setting.Name, False, "thumbnails.aspx", "operation", PhotoManager.Operations.ViewXML, "album") & "="
      Dim Srcs(), Titles() As String
      Dim N, Checked As Integer
      If Not Setting.PhotoAlbums Is Nothing Then
        For Each Album As String In Setting.PhotoAlbums
          Dim PhotoAlbum As PhotoAlbum = PhotoManager.PhotoAlbum.Load(Album)
          If PhotoAlbum IsNot Nothing Then
            AddValue(Srcs, JavascriptPhotosList(Setting, PhotoAlbum.Name))
            Dim Title As String = PhotoAlbum.Title(Setting.Language)
            If Title = "" Then
              Title = PhotoAlbum.Name
            End If
            AddValue(Titles, Title)
            If PhotoAlbum.Name = CurrentAlbum Then Checked = N
            N += 1
            For Each SubPhotoAlbum As PhotoAlbum In PhotoAlbum.PhotoAlbums(False)
              AddValue(Srcs, JavascriptPhotosList(Setting, SubPhotoAlbum.Name))
              Dim TitleSubPhotoAlbum As String = SubPhotoAlbum.Title(Setting.Language)
              If TitleSubPhotoAlbum = "" Then
                TitleSubPhotoAlbum = SubPhotoAlbum.Name
              End If
              AddValue(Titles, TitleSubPhotoAlbum)
              If SubPhotoAlbum.Name = CurrentAlbum Then Checked = N
              N += 1
            Next
          End If
        Next
      End If
      If Page.IsPostBack Then
        Checked = Val(Request.Form("ctl00$ContentPlaceHolder1$PhotoSource"))
        CurrentPhoto = Request.Form(PhotoList.UniqueID)
      End If
      AddScriptClientPopulateListPhotos(PhotosSourceSelect, PhotoList, Titles, Checked, CurrentPhoto, 0, Srcs)

    End If
  End Sub

  Private Sub AddValue(ByRef Array() As String, ByRef Value As String)
    If Array Is Nothing Then
      ReDim Array(0)
    Else
      ReDim Preserve Array(UBound(Array) + 1)
    End If
    Array(UBound(Array)) = Value
  End Sub

  Private Sub Submit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Submit.Click
    Dim UpdateCorrelatedLinks As Boolean
    Dim MetaTags As New MetaTags
    'Mantain old tags
    If NPage AndAlso IO.File.Exists(PageNameFile(Archive, NPage, Language)) Then
      Dim OldDocument As New HtmlDocument(PageNameFile(Archive, NPage, Language))
      MetaTags = OldDocument.MetaTags
      MetaTags.Title = TitlePage.Text
      MetaTags.Description = Description.Text
      MetaTags.KeyWords = KeyWords.Text
      If MetaTags.Author = "" Then
        MetaTags.Author = CurrentUser.Username
      End If
      If MetaTags.Collection("CorrelatedKeyWords") <> CorrelatedWords.Text Then
        UpdateCorrelatedLinks = True
      End If
    Else
      MetaTags = New MetaTags(TitlePage.Text, Description.Text, KeyWords.Text, CurrentUser.Username)
      MetaTags.AddMetaTag("Date", DateToText(Now.ToUniversalTime))
    End If
    'Dim ShowDateValue As EnabledStatus = ShowDate.SelectedValue 'Work correctly only if EnableViewStateMac="false"
    Dim ShowDateValue As EnabledStatus = Request.Form(ShowDate.UniqueID)
    If ShowDateValue <> EnabledStatus.Default Then
      MetaTags.AddMetaTag("ShowDate", Request.Form(ShowDate.UniqueID))
    End If
    MetaTags.AddMetaTag("EnabledComments", EnabledComments.Checked)
    MetaTags.AddMetaTag("CorrelatedKeyWords", CorrelatedWords.Text)

    Dim Status As SubSite.CerrelatedStructure.CorrelatedStatus
    If CW_Enabled.Checked Then
      Status = Config.SubSite.CerrelatedStructure.CorrelatedStatus.Enabled
    ElseIf CW_SameDomain.Checked Then
      Status = Config.SubSite.CerrelatedStructure.CorrelatedStatus.Context
    ElseIf CW_NotEnabled.Checked Then
      Status = Config.SubSite.CerrelatedStructure.CorrelatedStatus.NotEnabled
    End If

    If NPage Then
      Dim OldStatus As SubSite.CerrelatedStructure.CorrelatedStatus = MetaTags.Collection("CorrelatedStatus")
      If OldStatus <> Status Then
        UpdateCorrelatedLinks = True
      End If
    End If

    MetaTags.AddMetaTag("CorrelatedStatus", Status)

    If AddPhotoAlbum.Checked Then
      If Request.Form("ctl00$ContentPlaceHolder1$PhotoSource") <> "" Then
        Dim NAlbum, N As Integer
        NAlbum = Val(Request.Form("ctl00$ContentPlaceHolder1$PhotoSource"))
        Dim NameAlbum As String
        For Each Album As String In Setting.PhotoAlbums
          Dim PhotoAlbum As PhotoAlbum = PhotoManager.PhotoAlbum.Load(Album)
          If PhotoAlbum IsNot Nothing Then
            If NAlbum = N Then
              NameAlbum = PhotoAlbum.Name
            End If
            N = N + 1
            For Each SubPhotoAlbum As PhotoAlbum In PhotoAlbum.PhotoAlbums(False)
              If NAlbum = N Then
                NameAlbum = SubPhotoAlbum.Name
              End If
              N = N + 1
            Next
          End If
        Next
        If NameAlbum <> Nothing Then
          MetaTags.AddMetaTag("PhotoAlbum", NameAlbum)
        End If
      End If
    Else
      MetaTags.RemoveMetaTag("PhotoAlbum")
    End If

    If Request(PhotoList.UniqueID) <> "" Then
      'Add photo
      MetaTags.AddMetaTag("Photo", Request(PhotoList.UniqueID))
    Else
      MetaTags.RemoveMetaTag("Photo")
    End If

    Dim Video As String = ExtrapolateVideoID(VideoID.Text)
    If Video <> "" Then
      'Add video
      MetaTags.AddMetaTag("Video", Video)
    Else
      MetaTags.RemoveMetaTag("Video")
    End If
    If Setting.SEO.AutomaticallyDelimitsBlocksOfCodeInTheText Then
      AddTagSamp(Html.Value)
    End If
    Dim Document As New HtmlDocument(MetaTags, HtmlToXhtml(Html.Value), Language)

    Dim SaveToPage As Integer = NPage
    WriteAll(Document.Html, PageNameFile(Archive, SaveToPage, Language))
    If NPage = 0 Then
      'is a new page
      RedirectToPagesmanager = True
      NewNPage.Value = SaveToPage
      UpdateItemMenu() 'Add a new page to menu
    Else
      UpdateItemMenu()
      'ModifyPageIntoMenu(NPage)
    End If
    MasterPage.AddMessage(Setting, 3020)
    If Setting.Aspect.SuggestTheBestChoiceByTheBlink Then
      BlinkPageManegerButton = True
    End If
    If UpdateCorrelatedLinks Then
      Polling.UpdateDefaultLinks.Start()
    End If
  End Sub

  Private Sub Delete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Delete.Click
    Dim NameFile As String = MenuManager.PageNameFile(Archive, NPage, Language)
    Dim Code As String = FileManager.ReadAll(NameFile)
    Dim MetaTags As New MetaTags(Code)
    If DeletePermission(MetaTags.Author) Then
      MenuManager.UnSetDescription(Archive, NPage, Language)
      IO.File.Delete(NameFile)
      UpdateItemMenu()
      'Delete comments
      If MetaTags.MetaTag("IdComments") <> 0 Then
        Topic.Delete(ReservedForums.ArchiveComment, MetaTags.MetaTag("IdComments"))
      End If
      MasterPage.AddMessage(Setting, 3019)
    End If
  End Sub

  Private Function DeletePermission(ByVal Author As String) As Boolean
    If CurrentUser.Role(Setting.Name) > Authentication.User.RoleType.AdministratorJunior Or (StrComp(CurrentUser.Username, Author, CompareMethod.Text) = 0 And CurrentUser.Role(Setting.Name) >= Authentication.User.RoleType.AdministratorJunior) Then
      Return True
    End If
  End Function

  Sub UpdateItemMenu()
    'Add new page or remove deleted page
    Dim Menu As Menu = Menu.Load(Archive, Language)
    Menu.UpdateItemsMenu()
  End Sub

  Private BlinkPageManegerButton As Boolean
  Public RedirectToPagesmanager As Boolean
  Protected Sub Submit_PreRender(sender As Object, e As System.EventArgs) Handles Submit.PreRender
    'MasterPage.AddButton(Common.ButtonsStandard.PageManager, BlinkPageManegerButton AndAlso IsPostBack)
    Dim GoToUrl As String = Href(Setting.Name, False, "pagesmanager.aspx", "archive", Archive)
    If RedirectToPagesmanager Then
      SetNextMessage(3020)
      Response.Redirect(GoToUrl, True)
    End If
    MasterPage.AddButton(Phrase(Setting.Language, 3018), GoToUrl, , Components.IconType.ControlPanel, , True, , BlinkPageManegerButton AndAlso IsPostBack)
    If Not IsPostBack AndAlso Setting.Aspect.SuggestTheBestChoiceByTheBlink Then
      MasterPage.Blink(Submit)
    End If
  End Sub
End Class
